package roboforge;

//import java.util.Enumeration;
import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;
import javax.media.j3d.PickBounds;

import roboforge.geometry.*;

public class BCollision  {
/*  This will be a simple Collision Class that implemets intersection collision
    We do not know exactly what j3d is going to do with collitions so we will not expend the time to implement full collisions yet
    Hence this class will provide methods for the following model:

    2 Shapes will be viewed as collided if 1 or more polygons from each Shape intersect.

    This will fail in the following cases::

    One object in wholy inside the other

    But ... it will do for now */

    public BCollision()
    {
    }

    public void initialize()
    {
    }

    // HORRIBLE STATIC TEMPORARY OBJECTS
    // probably cause huge amouts of problems later, but we need to reduce garbage collection
    private static Transform3D aVWorld = new Transform3D();
    private static Transform3D bVWorld = new Transform3D();
    private static Transform3D lTransform = new Transform3D();
    private static Transform3D lMemberTransform = new Transform3D();

    private static Point3d pA = new Point3d();
    private static Point3d pB = new Point3d();
    private static Point3d pC = new Point3d();

    private static Point3d p1 = new Point3d();
    private static Point3d p2 = new Point3d();
    private static Point3d p3 = new Point3d();
    //private static Point3d p4 = new Point3d();
    //private static Point3d p5 = new Point3d();
    //private static Point3d p6 = new Point3d();
    //private static Point3d p7 = new Point3d();
    //private static Point3d p8 = new Point3d();
    //private static Point3d pA2 = new Point3d();
    //private static Point3d pB2 = new Point3d();
    //private static Point3d pC2 = new Point3d();


    private static PickSegment lSeg = new PickSegment();
    private static PickSegment sA = new PickSegment();
    private static PickSegment sB = new PickSegment();
    private static PickSegment sC = new PickSegment();

    //private static PickSegment sA2 = new PickSegment();
    //private static PickSegment sB2 = new PickSegment();
    //private static PickSegment sC2 = new PickSegment();

    //private static PickSegment s1 = new PickSegment();
    //private static PickSegment s2 = new PickSegment();
    //private static PickSegment s3 = new PickSegment();
    //private static PickSegment s4 = new PickSegment();
    //private static PickSegment s5 = new PickSegment();
    //private static PickSegment s6 = new PickSegment();
    //private static PickSegment s7 = new PickSegment();
    //private static PickSegment s8 = new PickSegment();
    //private static PickSegment s9 = new PickSegment();
    //private static PickSegment s10 = new PickSegment();
    //private static PickSegment s11 = new PickSegment();
    //private static PickSegment s12 = new PickSegment();



     public static boolean boundsIntersect(Node a, Node b)
     // PRE:: a and b have had their capabilities set for::
     // ALLOW_BOUNDSREAD, ALLOW_LOCALTOVWOLRD
    {
      boolean hit = false;


      //BDebug.print( "BCollision boundsIntersect a " + a);
      //BDebug.print( "BCollision boundsIntersect b " + b);

      Bounds aBounds;
      aBounds = (Bounds) a.getBounds().clone();

      a.getLocalToVworld(aVWorld);
      aBounds.transform(aVWorld);

      Bounds bBounds;
      bBounds = (Bounds) b.getBounds().clone();
      b.getLocalToVworld(bVWorld);
      bBounds.transform(bVWorld);

      hit = aBounds.intersect(bBounds);

    
      return  hit;
    }




    public static boolean boundsIntersect(BBot a, BBot b)
    // checks to see if the bounds of a collides with the bounds for b AND ALL IT's CHILDREN
    {


      return boundsIntersect(a.getChassis().getLiveNode(),  b.getChassis().getLiveNode());

    }


    public static boolean aShapeInterectsbBounds(BComponent a, BComponent b)
    {
      boolean hit = false;

      if (a.liveShapes.size() == 1)
        hit = boundsIntersect(a.getArbitraryShape_live(), b.getLiveNode());
      else
        hit = boundsIntersect(a.myShapesNode, b.getLiveNode() );


      return  hit;
    }


    private static Point3d boundsFurtherThanDistance_p = new Point3d();

    public static boolean boundsFurtherThanDistance(double distance, Node aNode, Point3d pointToTakeDistanceFrom )
    // distance must be in canvas units
    {
      Bounds aBounds;
      aBounds = aNode.getBounds();

      aNode.getLocalToVworld(aVWorld);
      aBounds.transform(aVWorld);

      if (aBounds instanceof BoundingSphere )
      {
        BoundingSphere aSph =  (BoundingSphere)aBounds;
        aSph.getCenter(boundsFurtherThanDistance_p);
        //boundsFurtherThanDistance_p.y = 0;

        double boundsdistance = boundsFurtherThanDistance_p.distance(pointToTakeDistanceFrom) + aSph.getRadius();

        return boundsdistance > distance;


      }
      /*else if (aBounds instanceof BoundingBox )
      {
        BDebug.print ("BCollision EE
      }*/
      else
        BDebug.print( "BCollision.boundsFurtherThanDistance. Bounds ASSERTION ERROR NOT  SPHERE ");


      return false;
    }




    private static Point3d boundsIntersectFloorCentre = new Point3d();
    public static boolean boundsIntersectFloor(   Node aNode  )
    {

      Bounds aBounds;
      aBounds = aNode.getBounds();

      aNode.getLocalToVworld(aVWorld);
      aBounds.transform(aVWorld);

      if (aBounds instanceof BoundingSphere )
      {
        BoundingSphere aSph =  (BoundingSphere)aBounds;
        aSph.getCenter(boundsIntersectFloorCentre);
        return (  boundsIntersectFloorCentre.y - aSph.getRadius() ) < 0;


      }
      else if (aBounds instanceof BoundingBox )
      {
        BoundingBox aBox =  (BoundingBox)aBounds;
        aBox.getLower(boundsIntersectFloorCentre);
        if (boundsIntersectFloorCentre.y < 0 )
          return true;

        aBox.getUpper(boundsIntersectFloorCentre);
        return (boundsIntersectFloorCentre.y < 0 );
      }
      else
        BDebug.print( "BCollision.boundsIntersectFloor. Bounds ASSERTION ERROR NOT BOX OR SPHERE ");


      return false;
      //Bounds floorBounds = BArena.getFloorCollisionBox();
      //return floorBounds.intersect(aBounds);

    }





     public static boolean intersectFloor(BShape3D a)
    {

     return  a.getIsBelowGround();


    }


    public static boolean outOfBounds(BComponent a)
    {
      return outOfBounds (a, ( a.getBot().getArena().getSize() / 2.0) * BGlobal.WORLD_TO_CANVAS_SCALE );

    }

    public static boolean outOfBounds(BComponent a, double distance)
    {

      boolean hit = false;

      Vector aVector = a.liveShapes;

      if (aVector.size() == 1)
        return a.getArbitraryShape_live().outOfBounds(distance);
      else
      {

        for (int i = 0; i< aVector.size(); i++)
        {
          BShape3D current = (BShape3D)aVector.get(i);
          if  (  current.outOfBounds(distance)  )
            return true;

        }
      }

      return hit;
    }


    public static boolean intersectFloor(BComponent a)
    {

      boolean hit = false;

      Vector aVector = a.liveShapes;

      if (aVector.size() == 1)
        return intersectFloor(a.getArbitraryShape_live() );
      else
      {
        for (int i = 0; i< aVector.size(); i++)
        {
          BShape3D current = (BShape3D)aVector.get(i);
          if  ( intersectFloor(current) )
            return true;

        }
      }

      return hit;
    }



     public static boolean boundsIntersect(BComponent a, Point3d origin, Vector3d direction)
    {
      boolean hit = false;

      Node aNode;

      if (a.liveShapes.size() == 1)
       aNode = a.getArbitraryShape_live();
      else
        aNode = a.myShapesNode;

      Bounds aBounds;
      aBounds = aNode.getBounds();

      aNode.getLocalToVworld(aVWorld);
      aBounds.transform(aVWorld);


      hit = aBounds.intersect(origin, direction);



      return  hit;
    }




      public static boolean boundsIntersect(BComponent a, BComponent b)
    {
      boolean hit = false;

      Node aNode;
      Node bNode;

      if (a.liveShapes.size() == 1)
       aNode = a.getArbitraryShape_live();
      else
        aNode = a.myShapesNode;

      if (b.liveShapes.size() == 1)
       bNode = b.getArbitraryShape_live();
      else
        bNode = b.myShapesNode;

      hit = boundsIntersect(aNode, bNode);



      return  hit;
    }

    public static boolean detects ( BBot currentBot, BArenaObject triggerObject )
    // SHOULD BE MOVED TO BBOT

    {
        //boolean hit = false;


        // BDebug.print ("a " + a);
        //BDebug.print ("b " + b);

        BSensor[] sensors = currentBot.getSensors();

       // BDebug.print ("sensorShapes " + b);

        BSensor current;

        for( int i = 0; i < sensors.length; i++ )
        {
          current = sensors[i];
          if ( current.detects(triggerObject))
          {

           // BDebug.print ("BCollision detects " + triggerObject);
            return true;
          }
         // else
            ///BDebug.print ("BCollision DOES NOT detect " + triggerObject);


        }





     
      return false;



    }


  public static boolean intersect(PickSegment seg, BShape3D intTest, javax.media.j3d.Locale myLocale)
  {
     intTest.getLocalToVworld(aVWorld);
     SceneGraphPath simplePath = new SceneGraphPath(myLocale, intTest) ;
     simplePath.setTransform(aVWorld);

     return intTest.intersect(simplePath, seg);




  }


  public static boolean intersect(PickSegment seg, BComponent intTest, javax.media.j3d.Locale myLocale)
  {
     Vector shapesVector = intTest.liveShapes;

     for (int i = 0; i< shapesVector.size(); i++)
     {
        BShape3D b = (BShape3D) shapesVector.get(i);
        if (intersect(seg,b,myLocale) )
          return true;

     }



     return false;


   }


   public static boolean intersect(BComponent a, BComponent b, javax.media.j3d.Locale myLocale, boolean checkBounds, boolean checkShapeBounds)
    {
      boolean hit = false;


      // specialCase, Check Floor
      if (a == BArena.arenaComponent)
      {
       // boolean outOfBounds =  outOfBounds(b) ;
       // boolean floorb =  intersectFloor(b);
       // BDebug.print("BCollision.intersect arena outOfBounds:" + outOfBounds + " floor:" +floorb );
       return outOfBounds(b) || intersectFloor(b)  ;

      }
      else if ( b ==  BArena.arenaComponent )
      {
       // boolean outOfBounds =  outOfBounds(a) ;
       // boolean floorb =  intersectFloor(a);
       // BDebug.print("BCollision.intersect arena outOfBounds:" + outOfBounds + " floor:" +floorb );
       return outOfBounds(a) || intersectFloor(a);


        //BDebug.assert(false, "BCollision.arenaFloor Removed");
       //return  outOfBounds(a) || intersectFloor(a);
      }

      // continue

      // check bounding shapes
      if (checkBounds)
      {
         hit = boundsIntersect(a,b);
      }
      else
         hit = true;


        //if (hit)
        if (hit)
        {


        // CHECK CACHE
        //------------------------------------
         if ( (a.lastCollidedShape != null) || (b.lastCollidedShape != null) )
         {
                //PickSegment lSeg = null;
                BShape3D lShape = null;
                Shape3D lMemberShape = null;

                //Point3d pA = null;
                //Point3d pB = null;

                if (a.lastCollidedShape != null)
                {

                        if (a.lastCollidedShape.getComponent() == b)
                        {
                                pA.x = a.getLastCollidedp1().x;
                                pA.y = a.getLastCollidedp1().y;
                                pA.z = a.getLastCollidedp1().z;

                                pB.x =  a.getLastCollidedp2().x;
                                pB.y =  a.getLastCollidedp2().y;
                                pB.z =  a.getLastCollidedp2().z;

                                lMemberShape = a.lastCollidedMemberShape;
                                lShape = a.lastCollidedShape;
                               // lTransform = aVWorld;
                        }
                        //else
                        // BDebug.print (a.lastCollidedShape.getComponent() + " == " + b + " failed ");


                }
                else
                {

                        if (b.lastCollidedShape.getComponent() == a)
                        {
                                pA.x = b.getLastCollidedp1().x;
                                pA.y = b.getLastCollidedp1().y;
                                pA.z = b.getLastCollidedp1().z;

                                pB.x =  b.getLastCollidedp2().x;
                                pB.y =  b.getLastCollidedp2().y;
                                pB.z =  b.getLastCollidedp2().z;

                                lMemberShape = b.lastCollidedMemberShape;
                                lShape = b.lastCollidedShape;
                                //lTransform = bVWorld;
                        }
                       // else
                         //BDebug.print (b.lastCollidedShape.getComponent() + " == " + a + " failed ");

                }




                if (lShape != null)
                {
                        lShape.getLocalToVworld(lTransform);
                        lMemberShape.getLocalToVworld(lMemberTransform);;
                        SceneGraphPath simplePath = new SceneGraphPath(myLocale, lShape) ;
                        simplePath.setTransform(lTransform);

                        /*
                        if ( a.toString().startsWith("C25") )
        								{
          								Vector3f aVWorld_v3f = new Vector3f();
          								lTransform.get(aVWorld_v3f);
          								BDebug.print("BCollision.intersect (cache): "+a.toString()+" - x="+aVWorld_v3f.x+" y="+aVWorld_v3f.y+" z="+aVWorld_v3f.z);
        								}
                        */


                      //  BDebug.print ("BCollision.intersect Cache :: points " + pA + " " + pB);
                        lMemberTransform.transform(pA);
                        lMemberTransform.transform(pB);


                        lSeg.set(pA, pB);

                      //  BDebug.print ("BCollision.intersect Cache :: after Transform " + pA + " " + pB);


                        if (lShape.intersect(simplePath, lSeg) )
                        {
                        				//BDebug.print ("BCollision.intersect: Cache Collision Detected");
                                return true;
                        }
                        //else
                                // BDebug.print ("BCollision.intersect :: Chache Collision NOT Detected");
                }
                // BDebug.print ("BCollision.intersect(BComponent BComponent ) Cached different Component Checking ");

         }
         // END CHECKING CACHE


         // Checking all shapes

          hit = false;
          Vector aVector = a.liveShapes;
          Vector bVector = b.liveShapes;

          BShape3D aC;
          BShape3D bC;

          // for speed up check if the components only have 1 shape
          if (   (aVector.size() ==1) && (bVector.size() == 1) )
              return intersect(a.getArbitraryShape_live(), b.getArbitraryShape_live() ,  myLocale, true, true, checkShapeBounds);

          // else check the lists


          for (int aIndex = aVector.size() - 1; aIndex >=0; aIndex--)
            for (int bIndex = bVector.size() - 1; bIndex >=0; bIndex--)
            {
              aC = (BShape3D) aVector.get(aIndex);
              bC = (BShape3D) bVector.get(bIndex);
              if (intersect(aC, bC,  myLocale, true, true, checkShapeBounds) )
                return true;
            }



      }  // if hit

    return hit;

    }



    private static Vector3d middleOfNode = new Vector3d();

    public static boolean bBoundsIntersect(Node theNode, BBox theBox, javax.media.j3d.Locale myLocale)
    // Returns true if the point at the centre of the node is in the box
    {
      //BDebug.print ("bBoundsIntersect(Node theNode, BBox theBox, javax.media.j3d.Locale myLocale) called ");


      theNode.getLocalToVworld(aVWorld);
      //Vector3d middleOfNode = new Vector3d();
      aVWorld.get(middleOfNode);

      theBox.getLocalToVworld(bVWorld);

      Point3d upper = p1;
      Point3d lower = p2;

      upper.set(theBox.getUpper() );
      lower.set(theBox.getLower() );
      bVWorld.transform(upper);
      bVWorld.transform(lower);

      //BDebug.print( "bBoundsIntersect checking middleOfNode" + middleOfNode);
      //BDebug.print( "bBoundsIntersect checking upper" + upper);
      //BDebug.print( "bBoundsIntersect checking lower" + lower);

      boolean hit =  (middleOfNode.x <= upper.x) && (middleOfNode.x >= lower.x); 
      hit = hit && (middleOfNode.y <= upper.y) && (middleOfNode.y >= lower.y);

      // right hand or left hand system?
      if (upper.z > lower.z )
        hit = hit && (middleOfNode.z <= upper.z) && (middleOfNode.z >= lower.z);
      else
        hit = hit && (middleOfNode.z >= upper.z) && (middleOfNode.z <= lower.z);
        
      return hit;

    }

    public static boolean bBoundsIntersect(BComponent armingComponent, BBox theBox, javax.media.j3d.Locale myLocale)
    {

      Vector bVector = armingComponent.liveShapes;
      BShape3D bC;

      if (bVector.size() == 1)
        return bBoundsIntersect( theBox, armingComponent.getArbitraryShape_live() ,myLocale);


      for (int i = 0; i < bVector.size(); i++)
      {
          bC =  (BShape3D)bVector.get(i);

          if(BCollision.bBoundsIntersect( theBox, bC ,myLocale))
            return true;

      }



      return false;

    }


    public static boolean bBoundsIntersect(Shape3D a, BShape3D b,  javax.media.j3d.Locale myLocale )
    {
      return bBoundsIntersect(a, b,myLocale , true);
    }

   // private static BoundingBox BoundingBoxb = new  BoundingBox();
    //private static PickBounds aShapeHull = new PickBounds();
    private static PickBounds bShapeHull = new PickBounds();


    public static boolean bBoundsIntersect(Shape3D a, BShape3D b,  javax.media.j3d.Locale myLocale , boolean checkReverse)
    {

      // get transforms
      a.getLocalToVworld(aVWorld);

      //  BDebug.print ("bBoundsIntersect called for " + b.getComponent());
      b.getLocalToVworld(bVWorld);

      SceneGraphPath simplePath = new SceneGraphPath(myLocale, a) ;
      simplePath.setTransform(aVWorld);

      BoundingPolytope bPolyTope = (BoundingPolytope)b.getConvexHull().clone();

      bPolyTope.transform(bVWorld);
      //PickBounds bShapeHull = new PickBounds(bPolyTope);
      bShapeHull.set(bPolyTope);


      // reverse polytope test
      boolean hit = a.intersect(simplePath, bShapeHull);

    //  if (a instanceof BShape3D)
    //    BDebug.print ("bBoundsIntersect called for " + ((BShape3D)a).getComponent() + " result " + hit);

      if (hit && checkReverse)
      {
        if (a instanceof BShape3D)
          hit = bBoundsIntersect(b, (BShape3D)a, myLocale, false)  ;

      }

      return hit;

    }

  private static int[] stripCountArray = new int[10];
  // private static PickBounds shapeHull = new PickBounds();

  private static boolean intersect(BShape3D a, BShape3D b, javax.media.j3d.Locale myLocale, boolean checkReverse, boolean cacheSegment, boolean checkBounds)
    // PRE :: boundsInterected has been checked
    {

      boolean hit = false;
      boolean boundsIntersected = false;

    //  BDebug.print ("BCollision.intersect(Shape3d, shape3d) checking bounds" + a.getComponent() + " " + b.getComponent()  );

     /* if ( b.getComponent().getIsConvex() )
      {
        //BDebug.print ("BCollision.intersect a is CONVEX" );
        hit =  bBoundsIntersect( a,  b, myLocale, false);
      }
      else if ( a.getComponent().getIsConvex() )
      {
       // BDebug.print ("BCollision.intersect b is CONVEX"  + a.getComponent() + " " + b.getComponent()  );
        hit =  bBoundsIntersect( b,  a, myLocale, false);
      }
      else
      {       */     
      if(checkBounds)
      {
        hit = bBoundsIntersect( a,  b, myLocale, true);
        //if ( !hit )
        //  BDebug.print ("BCollision.intersect: bBounds don't collide - "  + a.getComponent() + " " + b.getComponent()  );
      }
      else
       {
          hit = true;

          if  ( BGlobal.getCollisionCode() != BGlobal.COLLISION_FULL )
            if (  !a.getIsPartOfSameBot(b) )
              hit = bBoundsIntersect( a,  b, myLocale, true);
       }

    //  }
      // full collisions are always used for self collision tests

      if  ( BGlobal.getCollisionCode() != BGlobal.COLLISION_FULL )
        if (  !a.getIsPartOfSameBot(b) )
           return hit;


      if (hit)
      {
        // Transform3D aVWorld = new Transform3D();
        a.getLocalToVworld(aVWorld);

        /*
        if ( a.getComponent().toString().startsWith("C25") )
        {
          Vector3f aVWorld_v3f = new Vector3f();
          aVWorld.get(aVWorld_v3f);
          BDebug.print("BCollision.intersect (shape): "+a.getComponent().toString()+" - x="+aVWorld_v3f.x+" y="+aVWorld_v3f.y+" z="+aVWorld_v3f.z);
        }
        */

        // Transform3D bVWorld = new Transform3D();
        b.getLocalToVworld(bVWorld);

        boundsIntersected = true;
        SceneGraphPath simplePath = new SceneGraphPath(myLocale, a) ;
        simplePath.setTransform(aVWorld);

        //BDebug.print ("BCollision.intersect(Shape3d, shape3d)  Bounds Intersected, checking geometry" + a.getComponent() + " " + b.getComponent()  );

        // reset hit so that we can test geometry
        hit = false;
        Geometry bGeo = b.getGeometry();

        if ((bGeo instanceof TriangleStripArray) )
        {

              TriangleStripArray bGeoA = (TriangleStripArray) bGeo;

              //int noTriangles = bGeoA.getVertexCount();
             // BDebug.print ("BCollisionno Triangles" + noTriangles );

             // BDebug.print ("BCollision Number of strips " + bGeoA.getNumStrips() );

              int numStrips =  bGeoA.getNumStrips();

              if (stripCountArray.length < numStrips )
                stripCountArray = new int[numStrips ];

              bGeoA.getStripVertexCounts(stripCountArray) ;

            //  BDebug.print ("Strip Array");
             // for ( int i = 0; i < numStrips; i++ )
            //  {
            //    BDebug.print ("[ " + stripCountArray[i] + " ] ");
            //  }

              for (int strips = 0; strips < numStrips ;strips++)
              {
                int accumulator = 0;
                int stripToProcess;

                // alternate the strips from each end of the array, because the strips near each other are more likeley to be next to each other in the array
                if (strips % 2 == 1 )
                  stripToProcess = (numStrips-1 ) - (strips / 2);
                else
                  stripToProcess = strips - (strips / 2);

                //BDebug.print ("BCollision stripToProcess " + stripToProcess );

                for (int accCounter = 0; accCounter < stripToProcess; accCounter++)
                  accumulator = accumulator +  stripCountArray[accCounter];

               // BDebug.print ("BCollision accumulator " + accumulator );

                int innerLoopEnd = (accumulator + stripCountArray[stripToProcess] )-2;
                for (int i = accumulator; i <  innerLoopEnd; i++)
                {

                 // BDebug.print ("BCollision checking triangle " + i + " to " + (i + 2) );
                 // if (i ==innerLoopEnd-1)
                 //   BDebug.print ("BCollision crossing last Triangle" );

                  // take a triangle from the beginning
                  bGeoA.getCoordinate(i ,pA);
                  bGeoA.getCoordinate(i + 1 ,pB);
                  bGeoA.getCoordinate(i + 2 ,pC);

                  p1.set(pA);
                  p2.set(pB);
                  p3.set(pC);

                  bVWorld.transform(pA);
                  bVWorld.transform(pB);
                  bVWorld.transform(pC);

/*                  BDebug.print ("BCollision pA " + pA );
                  BDebug.print ("BCollision pB " + pB );
                  BDebug.print ("BCollision pC " + pC );   */


                  sA.set(pB, pA);
                  sC.set(pC, pA);

                  // only do the last cross if it is the end
                  if (i ==innerLoopEnd-1)
                    sB.set(pB, pC);

                  if (a.intersect(simplePath, sA) )
                  {

                    if (cacheSegment)
                      b.getComponent().setCollisionCache(p1, p2 , b ,a );
                    return true;
                  }

                  if (a.intersect(simplePath, sC) )
                  {
                    if (cacheSegment)
                      b.getComponent().setCollisionCache(p1, p3 , b ,a );
                    return true ;
                  }

                  // only do this one if it is the last strip
                  if (i ==innerLoopEnd-1)
                    if (a.intersect(simplePath, sB) )
                    {
                      if (cacheSegment)
                        b.getComponent().setCollisionCache(p3, p2 , b ,a );
                      return true ;
                    }



                }


              }

          }

          else
              BDebug.print("BCollision.intersect(BShape3D, BShape3D) Assertion faliure: Shapes geometry is not  TriangleSTrip Array:: " + b);





      }

      // If intersects fail then we need to check the other way because of the way pick segments work
      // reverse them
      if ( checkReverse && boundsIntersected)
        return intersect(b, a,  myLocale, false, cacheSegment, checkBounds);
      else
        return false;


    }









}

