package roboforge;

//: BJointTransform

//import javax.media.j3d.*;
import java.io.*;


// Transient Wrapper Class for Joint Transforms (used in BattlePlayer)



public class BJointTransform implements Serializable
{

    static final long serialVersionUID = -1L;

    
    public BJoint joint;
    public BJointPosition transform;

    BJointTransform(BJoint jointIn, BJointPosition transformIn)
    {
      joint = jointIn;
      transform = transformIn;
    }

    public boolean equals(Object o)
    {
      boolean b = false;
      if (o instanceof BJointTransform)
      {
        b = ((BJointTransform)o).joint == joint;
      }

      return b;
    }

    public String toString()
    {
      return "Joint Transform for " + joint + " " + transform;
    }



}///:~
