package roboforge;



public class BStringFunctions
{

  public BStringFunctions()
    { }

  public static String parseStringIn (String stringIn)
  {
    // Replace all underscores with spaces
    stringIn = stringIn.replace((char)95,(char)32);

    return stringIn;
  }


  public static String parseStringOut (String stringIn)
  {

    // Replace all spaces with underscores
    stringIn = stringIn.replace((char)32,(char)95);

    // Remove all characters that aren't alphanumeric
    int i = 0;
    while (i < stringIn.length())
    {
      // Determine if each character is a valid character
      int c = (int)stringIn.charAt(i);

      if (!((c >  47 && c < 58) || (c >  64 && c <  91)|| (c >  98 && c < 123) || (c == 95)))
      {
        // Only allow 0-9 A-Z a-z and _
        if (i==0)
        {
          // We're at the begining of the string
          stringIn = stringIn.substring(++i,stringIn.length());
          i--;
        }
        else if (i == stringIn.length()-1)
        {
          // We're at the end of the string
          stringIn = stringIn.substring(0,stringIn.length()-1);
        }
        else
        {
          // The character is in the middle of the string
          stringIn = stringIn.substring(0,i) + stringIn.substring(++i,stringIn.length());
          i--;
        }
      }
      else
      {
        i++;
      }

    }

    // Return the string with all the illegal characters either removed or replaced
    return stringIn;
  }

}