package roboforge;

//import java.io.*;
//import java.util.*;
//import javax.swing.tree.*;
//import javax.swing.event.*;

//import javax.vecmath.*;
//import javax.media.j3d.*;
//import javax.swing.text.*;

import roboforge.btree.*;


public class BWizardLimb extends BLimb
{
  static final long serialVersionUID = -1L;
  private  BComponent parentComponent;

  private String description;

  public BWizardLimb(BComponent theComponent)
  {
    super(theComponent);
    parentComponent =  theComponent.getParent();

  }


  public void reattachToBot()
  {

    BDebug.print ("BWizardLimb reattaching " + components.getRoot() + " to " + parentComponent  );
    parentComponent.getTreeNode().add(   components.getRoot()     );

    BDebug.print (" parent " +  ((BComponentNode)components.getRoot()).getComponent()  );
    BDebug.print (" parent component  " +  ((BComponentNode)components.getRoot()).getComponent().getParent()  );

    
    // hack to work around a java bug.  This should happen automatically
    //components.getRoot().setParent( parentComponent.getTreeNode() );

    //parentComponent.getTreeNode().add(   components.getRoot()     );


  }


  public BComponent getParentComponent()
  {
    return parentComponent;

  }


  public void setName (String name)
  {
    this.name = name;
  }

  public String getName()
    { return name; }

  public String toString()
    { return name; }


  public void detachButRetainLinks()
    { components.getRoot().removeFromParent(); }


  public String getDescription()
  {
    return description;
  }

   public void setDescription (String newDesc)
  {
    description = newDesc;
  }




  
} 