package roboforge;

import java.io.*;
public class SComponentDetails implements Serializable
{
  /**
	 * 
	 */
	private static final long serialVersionUID = -1L;
/*
 
  * Description:
    Holds the results of a fight run by a fight client
  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 22-Feb-2000

  */
  String componentName;
  String componentType;
  String isSpecialWeapon;


  public SComponentDetails(String componentNameIn, String componentTypeIn, boolean isSpecialWeaponIn)
  {
    componentName = componentNameIn;
    componentType = componentTypeIn;

    // Oracle doesn't have a boolean datatype thus conversion is necessary

    if (isSpecialWeaponIn)
      isSpecialWeapon = "Y";
    else
      isSpecialWeapon = "N";
  }
} 
