package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BConstant extends BTerminal
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  // Member variables...
  // -------------------------------------------------------------

  protected BValue value;


  // Constructors...
  // -------------------------------------------------------------

  public BConstant(BConstant o)
  {
    super();
    this.value = (BValue) o.value.clone();
  }

  public BConstant(BValue value)
  {
    super();
    this.value = value;
  }

  public Object clone()
    { return new BConstant(this); }


  // Methods...
  // -------------------------------------------------------------

  public BValue evaluate()
    { return value; }

  public int getType()
    { return value.getType(); }

  public String toString()
    { return value.toString(); }
}
