package roboforge.animation;

public interface BAnimator
{

  public void start();  // start the animations

  public void stop();  // stop the animations

  public void add( BAnimation a); // add a animation
                                  // calls animation.start()

  public void remove( BAnimation b); // remove the animation
                                    // calls the animation.stop() callback

	public boolean contains(BAnimation a);
  	// Returns true if animator currently contains a.

  public void clear(); // clear all animations , calla animations .start()


} 