package roboforge.animation;

import roboforge.*;

import javax.media.j3d.*;
import java.util.*;

public class Bj3dFrameElapsedAnimator extends BAbstractAnimatorAdapter
// PLEASE NOTE,  unless This Class is sub classed, You will need to manually add the Behavior to the canvas universe
{
  Canvas3D canvas;
  protected BPlayerBehavior playerLoop;


  public Bj3dFrameElapsedAnimator(Canvas3D canvas, boolean autoActive)
  {
    super(autoActive);
    this.canvas = canvas;
    playerLoop = new BPlayerBehavior();

  }



  public void cleanse()
  {
    //BDebug.print("Bj3dFrameElapsed.cleanse called ");

    playerLoop = null;
    canvas = null;

    super.cleanse();
  }

  protected class BPlayerBehavior extends Behavior
  {
    WakeupOnElapsedFrames wFrame;

    public BPlayerBehavior()
    {

        this.setEnable(true);
        wFrame =  new WakeupOnElapsedFrames(0);
        this.setSchedulingBounds(BGlobal.INFINITE_BOUNDS);
    }

    public void initialize()
    {
      wakeupOn(wFrame);
    }

    public void processStimulus(Enumeration criteria)
    {
      //BDebug.print ("Bj3dFrameElapsedAnimator woke up");
      if (active)
        animate();

      wakeupOn(wFrame);

    }




  }





}