package roboforge.btree;

import roboforge.*;
import java.io.*;


public class BTreePair implements Serializable
{
  static final long serialVersionUID = -1L;

  private Object item;
  private Object parent;
  private String treeClassName;  // the name of the class of the tree node that contained the tree

  public BTreePair(Object item, Object parent, String treeClassName)
  {
    this.item = item;
    this.parent = parent;
    this.treeClassName = treeClassName;
  }

  public Object getItem()
  { return item; }

  public Object getParent()
  { return parent; }

  public String getTreeClassName()
  { return treeClassName; }

}