package roboforge.net.data;

import roboforge.util.data.*;


public class BAccountRankingData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BAccountRankingData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.ACCOUNT_RANKING; }


  // Status codes...
  // -------------------------------------------------------------
  public String professionalStatus;     // GM or M (Grandmaster or Master)


  // Data fields...
  // -------------------------------------------------------------
  public int totalProfFights;
  public int totalProfFightsWon;
  public int totalProfTournsWon;
  public int profRankingPoints;
  public int profRanking;
  public int totalAmateurFights;
  public int totalAmateurFightsWon;
  public int totalAmateurTournsWon;
  public int amateurRankingPoints;
  public int amateurRanking;
  public String accountBlurb;

  public String toString()
  {
    return professionalStatus;
  }
}
