package roboforge.net.data;

import roboforge.util.data.*;
import java.util.Vector;

public class BAcknowledgeChallengeData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BAcknowledgeChallengeData(long tournamentID, long challengeRoomID,
                                    String challengedBotName, boolean challengeAccepted,
                                    boolean botsValid, Vector validationIssues,
                                    String password, long accountID)
    {
      super(tournamentID);
      this.challengeRoomID        = challengeRoomID;
      this.challengedBotName      = challengedBotName;
      this.challengeAccepted      = challengeAccepted;
      this.botsValid              = botsValid;
      this.validationIssues       = validationIssues;
      this.password               = password;
      this.accountID              = accountID;
    }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_ACKNOWLEDGE_CHALLENGE; }


  // Status codes...
  // -------------------------------------------------------------


  // Data fields...
  // -------------------------------------------------------------
  public long challengeRoomID;
  public String challengedBotName;
  public boolean challengeAccepted;
  public boolean botsValid;
  public Vector validationIssues;
  public String password;
  public long accountID;

  // Accessor methods...
  // -------------------------------------------------------------

}