package roboforge.net.data;

import roboforge.util.data.*;


public class BCRTournamentData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BCRTournamentData(long tournamentID, String tournamentName, String tournamentStatus,
                            float percentageComplete, long challengerID, long challengedID,
                            String challengerDesignerName, String challengedDesignerName, long fightID)
    {
      super(tournamentID);
      this.tournamentName         = tournamentName;
      this.tournamentStatus       = tournamentStatus;
      this.percentageComplete     = percentageComplete;
      this.challengerID           = challengerID;
      this.challengedID           = challengedID;
      this.challengerDesignerName = challengerDesignerName;
      this.challengedDesignerName = challengedDesignerName;
      this.fightID                = fightID;
    }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_TOURNAMENT; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------
  public String tournamentName;
  public String tournamentStatus;
  public float percentageComplete;
  public long challengerID;
  public long challengedID;
  public String challengerDesignerName;
  public String challengedDesignerName;
  public long fightID;
  public String challengerBotName;
  public String challengedBotName;

  // Accessor methods...
  // -------------------------------------------------------------

  
}
