package roboforge.net.data;

import roboforge.util.data.*;


public class BChallengeConstantData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BChallengeConstantData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_CONSTANTS; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------

  public int maxNumberOfChallengeRooms;
  public int maxNumberOfParticipants;
  public float maxEntryCost;
  public float maxFightTime;

  // Accessor methods...
  // -------------------------------------------------------------

}
