package roboforge.ui.components.text;


public interface BTextGuard
{
  
  public boolean isValidInsertion(String cur, String ins, int offset);
    // Returns true if it is valid to insert 'ins' into 'cur' 
    // at position 'offset'.
  
  public boolean isValidDeletion(String cur, int offset, int length);
    // Returns true if it is valid to remove 'length' chars from 'cur',
    // starting at position 'offset'.
  
}
