package roboforge.ui.console;

public class BSimpleManagedTexture extends BManagedTexture
{

  // Internal variables...
  // -------------------------------------------------------------

  protected int top         = 0;
  protected int heightLeft  = 0;


  // Constructors...
  // -------------------------------------------------------------

  public BSimpleManagedTexture()
  {
    super();
    heightLeft = getHeight();
  }

  public BSimpleManagedTexture(int w, int h)
  {
    super(w, h);
    heightLeft = h;
  }

  public BSimpleManagedTexture(int format, int w, int h)
  {
    super(format, w, h);
    heightLeft = h;
  }


  // Accessor methods...
  // -------------------------------------------------------------

  public BTexturePortion requestPortion(int w, int h)
  {
    if ((h > heightLeft) || (w > getWidth()))
      return null;

    BTexturePortion p = new BTexturePortion(this, 0, top, w, h);

    top        += h;
    heightLeft -= h;

    return p;
  }

  public void returnPortion(BTexturePortion p)
    { }

}
