package roboforge.util.io;

import roboforge.BGlobal;
import java.io.File;


public class BFolderFilter extends BBasicFilter
{
  String[] extension;
  String description;
  boolean returnDirectories;

  public BFolderFilter(String[] suffix, String desc,boolean returnDirectories)
  {
    super(suffix);
    extension = suffix;
    description = description;
    this.returnDirectories = returnDirectories;
  }
    public String getDescription()
  {
    return description;
  }

  public boolean accept(File f)
  {
    // We may return directories.
    if (f.isDirectory())
    {
      if (returnDirectories)
        return true;
      else
        return false;
    }

    // So, it's a file, check it's extension.
    String name = f.getName();

    return super.accept(f, name);
  }
}