package roboforge;

import java.util.*;

public class BArenaObjects extends Vector
/*

* Description:
  Holds the BArena objects

* Example:
* Modification History ( Name, Date, Notes )
  Created HSC, 21 May.

*/
{

  public BArenaObjects()
  {
  }

  static final long serialVersionUID = 5113119051231344483L;

  public boolean add(Object arenaObject)
  {
    // Ensures that the added object implements the BArenaObject Interface.
    if (arenaObject instanceof BArenaObject)
    {
      return super.add(arenaObject);
    }
    else
    {
      throw new ClassCastException ("Object Doesn't Implement BArenaObject Interface");
    }
  }


  public void addElement(Object arenaObject)
  {
    // Ensures that the added object implements the BArenaObject Interface.
    if (arenaObject instanceof BArenaObject)
      super.addElement(arenaObject);
    else
      throw new ClassCastException ("Object Doesn't Implement BArenaObject Interface");
  }

  public void replacePlaceholder (BPlaceHolder placeHolder,BArenaObject arenaObject)
  {
    // Make the BArenaObject's position in the Arena, equal
    // the BPlaceHolder position's it is replacing
    arenaObject.setArenaPosition(placeHolder.getArenaPosition());

   // Check replace types *********


    int i = indexOf(placeHolder);
    set(i,arenaObject);
  }


}