package roboforge;

import roboforge.geometry.*;

public class BZoneShape extends BBox implements  BHighlightShape
{

  BZone theZone;

  public BZoneShape(BZone newZone , double xsize, double ysize, double zsize)
  {
    super( xsize, ysize, zsize );
    theZone =  newZone;



  }

  public BZone getZone()
  {
    return theZone;
  }


  public void setHighlight(boolean turnOn)
  {

    theZone.setHighlight(turnOn);


  }

  public boolean setActiveArea()
  {

    return true;
  }

  public void cleanse()
  {
    theZone = null;
    setAppearance(null);
  }


}