package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SDisplaySalesBean extends SJDBCBean
{

  private String sql;
  private Statement statement;
  private ResultSet rs;

  private String returnHTML;

  public SDisplaySalesBean() throws Exception
  {
    super();
  }

  public String getReturnHTML()
  {

    Connection con = null;
    String returnHTML = "";
    try
    {
      con = this.getConnection();

      // Request Doesn't involve a WP id
      sql = "SELECT count(*) AS count FROM TRANSACTION WHERE ref IS NOT NULL";

      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      rs.next();

      int count = rs.getInt("count");

      rs.close();
      statement.close();

      returnHTML = "<HTML><BODY>TOTAL SALES: " + count + "</BODY></HTML>";
      return returnHTML;
    }
    catch (Exception e)
    {
      System.err.println("Error: SLoginBean: " + e.getMessage());
    }
    finally
    {
      if (con != null)
        this.freeConnection(con);
    }

    return returnHTML;

  }
}