package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;



public class SProcessBug extends SHttpServletJXGB
{

  String html;
  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {
    // Taken out 4/07/00 As now doing redirect again
    //response.setStatus(HttpServletResponse.SC_MOVED_PERMANENTLY);

    Connection con = null;
    String email = "";
    String area = "";
    String type = "";
    String detail = "";
    String output = "";

    Statement statement = null;
    ResultSet rs = null;
    String sql = "";


    try
    {

     // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("*** Request is NULL");
        response.sendRedirect("http://www.roboforge.net/error.htm");
        return;
      }
      else
      {
        if (request.getParameter("EMAIL")== null || request.getParameter("AREA")== null || request.getParameter("TYPE")== null || request.getParameter("DETAIL")== null)
        {
          // This condition will most likely be reached if a
          // search Robot attempts to link to www.roboforge.net/Servlets/SPreRegisterServlet
          // Get them to contact roboforge
          System.err.println("NULL EMAIL or AREA or TYPE or DETAIL");
          response.sendRedirect("http://www.roboforge.net/beta/bugserr1.htm");
          return;
        }
      }

      if ((request.getParameter("EMAIL").equals("") || (request.getParameter("AREA").equals("")) || (request.getParameter("TYPE").equals("")) || (request.getParameter("DETAIL").equals(""))))
      {
        // An empty string for either the login or password get them to reenter
        response.sendRedirect("http://www.roboforge.net/beta/bugserr1.htm");
        return;
      }

      email = SServerAccess.parseString(request.getParameter("EMAIL"));
      area = SServerAccess.parseString(request.getParameter("AREA"));
      type = SServerAccess.parseString(request.getParameter("TYPE"));
      detail = SServerAccess.parseString(request.getParameter("DETAIL"));
      output = SServerAccess.parseString(request.getParameter("OUTPUT"));

      if (email.length() > 100)
        email = email.substring(0,100);

      if (area.length() > 50)
        area = area.substring(0,50);

      if (type.length() > 30)
        type = type.substring(0,30);

      if (detail.length() > 2000)
        detail = detail.substring(output.length()-2000,output.length());

      if (output.length() > 4000)
        output = output.substring(output.length()-4000,output.length());

      // Get the account details

      con = getDatabaseConnection();

      statement = con.createStatement();
      sql = "SELECT id, current_version FROM ACCOUNT WHERE LOWER(email) = LOWER('" +  email + "')";
      sql += " AND status = 'OPEN'";
      rs = statement.executeQuery(sql);

      //rs.next();

      //int count = rs.getInt("COUNT");

      if (rs.next())
      {
        // Found email so enter bug into database
        long accountID = rs.getLong("id");
        float currentVersion = rs.getFloat("current_version");

        rs.close();
        statement.close();


        // Enter Bug
        sql = "INSERT INTO BUG (account_id, area, type, detail, output, version)";
        sql += " VALUES (" + accountID + ",'" + area +"','" + type + "','"+ detail + "','" + output + "'," + currentVersion + ")";



        statement = con.createStatement();
        statement.executeUpdate(sql);

        statement.close();

        response.sendRedirect("http://www.roboforge.net/beta/bugsok.htm");
        return;
      }
      else
      {
        rs.close();
        statement.close();

        // InValid EMail address
        response.sendRedirect("http://www.roboforge.net/beta/bugserr2.htm");
        return;
      }
    }
    catch (Exception e)
    {
      System.err.println("Error SProcessBug.doPost: "+ e.getMessage());

      System.out.println("SQL :" + sql);
      //response.sendRedirect ("\\\\EDGE/Edge/Website/Mainsubok.htm");
      //response.sendRedirect(SGlobal.WEB_PAGE_LOCATION +"/subok.htm");
      response.sendRedirect("http://www.roboforge.net/error.htm");
      //response.setHeader("Location","/subok.htm");
      return;
      //response.sendRedirect("http://server.roboforge.com/subok.htm");
    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
          rs.close();
        if (statement != null)
          statement.close();

      }
      catch(Exception e3)
      {
        System.err.println("Error SProcessBug.myBroker.freeConnection: "+e3.getMessage());
      }
    }


  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();  
      /*
      Class.forName ("oracle.jdbc.driver.OracleDriver");
      con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      */
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }

    catch (Exception sqle)
    {
      System.err.println("Error SProcessBug.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SProcessBug Information";
  }
}
