package roboforge.ai.expressions;

import roboforge.ai.values.*;


public abstract class BBooleanBinaryOp extends BBinaryOp
{
  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected transient BBoolean value;

  public BBooleanBinaryOp()
    { super(); }

  public BBooleanBinaryOp(BBooleanBinaryOp o)
    { super(o); }

  public BBooleanBinaryOp(BExpression l, BExpression r)
    { super(l, r); }

  public void init()
    { value = new BBoolean(); super.init(); }
}
