package roboforge.ai.expressions;

import roboforge.ai.values.*;


public class BParenthesis extends BUnaryOp
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  public BParenthesis()
    { super(); }

  public BParenthesis(BParenthesis o)
    { super(o); }

  public BParenthesis(BExpression op)
    { super(op); }

  public Object clone()
    { return new BParenthesis(this); }

  protected BValue apply(BValue o)
    { return o; }

  public int applyType(int o)
    { return o; }

  public String toString()
    { return "("+ operand+ ")"; }

  public String getName()
    { return "("; }

}
