package roboforge.ai.orient;

import roboforge.*;
import java.io.*;


public abstract class BOrientSearchPattern implements Serializable
{
  // Class for searching for the enemy bot when not detected.

  static final long serialVersionUID = -1L;
  
  public abstract String getName();
  // return the name to appear in the Ui

  public abstract void executeSearch (float s, BBot bot);
  // perform a search slice for s seconds

  public abstract boolean stopOrient();
  // returns true if the currently executing orient should stop

  public abstract boolean executeOrient();
  // returns true if the orient should execute instead of the


  public String toString()
    { return getName(); }
}