package roboforge.ai.values;
                 
import java.io.*;

public class BString extends BValue
{

  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  protected String value;

  public BString()
    { this("");}

  public BString(String value)
  {
    this.type  = BType.STRING;
    this.value = value;
  }

  public String getValue()
    { return value; }

  public void setValue(String value)
    { this.value = value; }


  public void writeValue(DataOutput dout)  throws IOException
    { dout.writeUTF(value); }

  public void readValue(DataInput din) throws IOException
    { value = din.readUTF(); }


  public boolean equals(Object o)
  {
    if (o instanceof BString)
      return
        this.value.equals (((BString) o).value);
    else
      return false;
  }

  public String toString()
    { return "\""+ value+ "\""; }

  public void setValue(BValue v)
  {
    if (v instanceof BString)
    {
      BString b = (BString) v;
      this.value = b.value;
    }
  }

}
