package roboforge.ai.values;

import roboforge.BGlobal;
import roboforge.util.graphics.*;

import java.awt.Color;
import javax.swing.Icon;


public class BTypeIcons
{

  // UI Resources ...
  // -------------------------------------------------------------

  protected static Color ICON_COLOR =
    BGlobal.colors.getDarkShade();

  protected static Color SELECT_COLOR =
    BGlobal.colors.getWhiteShade();

      
  protected static Icon[] ICONS =
  {
    BGraphics.getHSBIcon("ai_type_icon_undefined.gif", ICON_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_number.gif",    ICON_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_boolean.gif",   ICON_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_string.gif",    ICON_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_enum.gif",      ICON_COLOR),
  };

  protected static Icon[] SELECTED =
  {
    BGraphics.getHSBIcon("ai_type_icon_undefined.gif", SELECT_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_number.gif",    SELECT_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_boolean.gif",   SELECT_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_string.gif",    SELECT_COLOR),
    BGraphics.getHSBIcon("ai_type_icon_enum.gif",      SELECT_COLOR),
  };

  
  
  public static Icon getIconForType(int type)
    { return ICONS[type]; }

  public static Icon getSelectedIconForType(int type)
    { return SELECTED[type]; }
    
}
