package roboforge.animation.alpha.map;


public interface BAlphaMap
{

  // A BAlphaMap maps a time value in seconds to a
  // corresponding alpha value in [0..1].


  public float alpha(float time);
    // Maps 'time' in seconds onto a alpha value.
    // Must return a value in [0..1].

  public boolean isValidTime(float time);
    // Returns true if 'time' is in the map's domain.

} 