package roboforge.animation.animation.b3d;

import roboforge.animation.*;
import javax.media.j3d.*;


public class B3dDeltaTransform implements BAnimation
{
  TransformGroup toModify;
  Transform3D delta;
  private Transform3D oldTransform = new Transform3D();

   public B3dDeltaTransform()
  { }

   public B3dDeltaTransform(TransformGroup toModify, Transform3D delta)
  {
    set(toModify, delta);
  }

  public void set (TransformGroup toModify, Transform3D delta)
  {
    this.toModify = toModify;
    this.delta = delta;
  }


  public boolean animate()
  {
      toModify.getTransform(oldTransform);
      oldTransform.mul(delta);
      toModify.setTransform(oldTransform);
      return true;
  }


  public void start()
  {}

  public void stop()
  {}


}


