package roboforge.botanalyst;

import roboforge.*;
import javax.media.j3d.*;
import java.awt.Color;

public class BComponentWarning extends BBotWarning
{

  private static float  COL_TRAN = 0.4f;
  private static Color  COL_HIGHLIGHT_COLOR = new Color(255,0,0);

  private static BComponentAppearance COL_HIGHLIGHT = new BComponentAppearance(
    COL_HIGHLIGHT_COLOR,
    BComponentAppearance.DEFAULTDEPTH,
    0f,
    null,
    COL_TRAN);


  BComponent component;
  public BComponentWarning(BComponent c)
  {
    super (c + " is invalid." , "This component has been changed or removed from the library, Bots containing this component will be rejected from internet tournaments." );
    this.component = c;

  }

   public void setHighlight(boolean b)
   {
    if (b)
      component.setHighlight(COL_HIGHLIGHT);
    else
      component.setNormalAppearance();
   }


} 