package roboforge.net.client;

import roboforge.net.*;
import roboforge.util.data.*;
import java.security.PublicKey;


public class BRequest extends BMessage
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;

  
  // Constructor...
  // -----------------------------------------------------------

  public BRequest(BClientStack source, String type)
    { this(source, type, null); }

  public BRequest(BClientStack source, String type, BData data)
  {
    super(data);

    String    user = source.getUserName();
    String    pass = source.getPassword();
    // PublicKey key  = source.getPublicKey();

    setHeader(new BRequestHeader(type, user, pass)); // , key));
  }

  public BRequestHeader getRequestHeader()
    { return (BRequestHeader) getHeader(); }

  
  public String getUser()
    { return getRequestHeader().getUser(); }

  public String getPassword()
    { return getRequestHeader().getPass(); }
  
  // public PublicKey getPublicKey()
  //   { return getRequestHeader().getPublicKey(); }

} 