package roboforge.net.data;

import roboforge.util.data.*;


public class BStartFightData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BStartFightData(long fightID, long tournamentID, String challengerName,
                          String challengedName, long challengerTEID,
                          long challengedTEID)
    {
      super(fightID);
      this.tournamentID     = tournamentID;
      this.challengerName   = challengerName;
      this.challengedName   = challengedName;
      this.challengerTEID   = challengerTEID;
      this.challengedTEID   = challengedTEID;
    }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.CR_START_FIGHT; }


  // Status codes...
  // -------------------------------------------------------------

  // Data fields...
  // -------------------------------------------------------------

  public long tournamentID;
  public String challengerName;
  public String challengedName;
  public long challengerTEID;
  public long challengedTEID;

  // Accessor methods...
  // -------------------------------------------------------------

}