package roboforge.particles.emitters;

import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;



public abstract class BParticleEmitter3D
  extends    BParticleAspectAdapter
  implements BParticleEmitter
{

  protected BSystemEmitter3D parent;


  public BParticleEmitter3D(BSystemEmitter3D parent)
    { this.parent = parent; }

  protected Transform3D getEmitterTransform()
    { return parent.getEmitterTransform(); }

  protected Point3f getOrigin()
  	{ return parent.getOrigin(); }

}

