package roboforge.ui.components;

import java.awt.Dimension;
import javax.swing.Action;


public class BActionButton extends BButton
{

  // Class variables...
  // -------------------------------------------------------------

  protected static final Dimension SIZE =
    new Dimension(31, 31);


  // Constructor.
  // -------------------------------------------------------------

  public BActionButton(BUIResources res, String key)
   { super(res, key); }

  public BActionButton()
    { super(); }

  public BActionButton(Action action)
  {
    super();
    setAction(action);
  }


  // Initialization helper...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    setMinimumSize(SIZE);
    setMaximumSize(SIZE);
    setPreferredSize(SIZE);
    
    setShowingText(false);

    super.initializeUI(res, key);
  }


  /*
  // Accessor methods...
  // -------------------------------------------------------------

  public void setText(String text)
    { } // Ignore, since we only allow an icon.
  */
  
} 