package roboforge.ui.components.text;



public class BIdentifierGuard extends BAbstractGuard
{

  protected static char UNDERSCORE = '_';

  public BIdentifierGuard()
    { super(); }

  protected boolean isValidChar(char c, int i)
  { 
    if (i == 0)
      if (Character.isDigit(c) || (c == UNDERSCORE))
        return false;

    if (Character.isLetterOrDigit(c))
      return true;
    
    if (c == UNDERSCORE)
      return true;
    
    return false; 
  }
  
}
