package roboforge.ui.net;

import roboforge.BGlobal;

import roboforge.ui.components.tree.*;

import roboforge.util.data.*;
import roboforge.util.graphics.*;

import java.awt.Color;
import javax.swing.Icon;


public class BDataIcons
{
  
  // UI Resources ...
  // -------------------------------------------------------------

  protected static Color WHITE = 
    Color.white;

  protected static Icon DEFAULT =
    BGraphics.getHSBIcon("net_tournament_icon.gif");

  protected static Icon DEFAULT_SELECT =
    BGraphics.getHSBIcon("net_tournament_icon.gif", WHITE);
  
  protected static Icon[] ICONS =
  {
    null,
    null,
    null,
    null,
    DEFAULT,
    null,
    BGraphics.getHSBIcon("net_bot_icon.gif"),
    BGraphics.getHSBIcon("net_fight_icon.gif"),
    null,
  };
  
  protected static Icon[] SELECT =
  {
    null,
    null,
    null,
    null,
    DEFAULT_SELECT,
    null,
    BGraphics.getHSBIcon("net_bot_icon.gif", WHITE),
    BGraphics.getHSBIcon("net_fight_icon.gif", WHITE),
    null,
  };
  

  public static Icon get(BDataAtom d)
  { 
    if (d != null)
      return (d.getType() >= 0) ?
        ICONS[d.getType()] : DEFAULT;
    else
      return DEFAULT;
  }
  
  public static Icon getSelected(BDataAtom d)
  { 
    if (d != null)
      return (d.getType() >= 0) ?
        SELECT[d.getType()] : DEFAULT_SELECT;
    else
      return DEFAULT_SELECT;
  }
  
}
