package roboforge.util.io;

import roboforge.util.text.*;


public class BRoboforgeFilter extends BInternalFilter
{

  public BRoboforgeFilter(String ext)
    { super(ext); }

  public BRoboforgeFilter(String[] exts)
    { super(exts); }


  public String toDisplayable(String name)
  {
    String s = super.toDisplayable(name);
    return BStrings.convertFromFilename(s);
  }

  public String toFilename(String name)
  {
    if (name == null)
      return null;

    String s =
      BStrings.convertToFilename(name);

    if (exts != null)
      s += exts[0];

    return s;
  }

} 