package roboforge;

import roboforge.animation.*;
//import roboforge.animation.alpha.*;

import javax.media.j3d.*;



public class BMobileArenaOrnament
  extends    BAnimatedArenaOrnament
{

  // Serialization ID.
  // -------------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructors...
  // -------------------------------------------------------------

  public BMobileArenaOrnament(String name, String filename)
    { super(name, filename); }



  // Initialization for arena...
  // -------------------------------------------------------------

  public void initArenaDetails(BArena arena)
  {
    super.initArenaDetails(arena);

    // TODO: Set Transform write capability
    // for arena position?
    
  }


  public void setLiveNodes(BranchGroup wrapperBranch, TransformGroup newDisplacementGroup, TransformGroup newArenaRotateGroup)
  {
    // Overridden to allow mobile ornaments to be
    // added/removed from the arena canvas.

    super.setLiveNodes(wrapperBranch, newDisplacementGroup, newArenaRotateGroup);

    Group parent
      = (Group) wrapperBranch.getParent();

    parent.setCapability(Group.ALLOW_CHILDREN_EXTEND);
    parent.setCapability(Group.ALLOW_CHILDREN_WRITE);

    setDirectLiveParentNode(parent);
  }




  // BAnimatedArenaOrnament implementation...
  // -------------------------------------------------------------

  public BAnimation getAnimation()
    // Default implementation does nothing.
    { return null; }

}