package roboforge.ai.expressions;

import roboforge.ai.values.*;


public abstract class BCompareBinaryOp extends BBooleanBinaryOp
{
  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;


  public BCompareBinaryOp()
    { super(); }

  public BCompareBinaryOp(BCompareBinaryOp o)
    { super(o); }

  public BCompareBinaryOp(BExpression l, BExpression r)
    { super(l, r); }


  protected int combineType(int l, int r)
  {
    if (l != r)
      return BType.UNDEFINED;

    else if (l == BType.NUMBER)
      return BType.BOOLEAN;

    else
      return BType.UNDEFINED;
  }
}
