package roboforge.ai.orient;

import roboforge.*;

import java.io.*;
import java.util.Vector;


public abstract class BOrient
  implements Cloneable, Serializable
{
  static final long serialVersionUID = -1L;


  public abstract boolean executeOrient(BBot bot);
    // Execute an orient slice.
    // Returns whether orientation has succeeded.

  public abstract String getName();

  public String toString()
    { return getName(); }

  public abstract Object clone();
    
}
