package roboforge.ai.values;

import roboforge.*;

public class BComponentType extends BEnumerated
{


  // Serialization ID.
  // -----------------------------------------------------------
  static final long serialVersionUID = -1L;

  public static String COMPONENT    = BComponent.COMPONENT_TYPE;
  public static String CONTROLLER   = BCpu.COMPONENT_TYPE;
  public static String ENERGY       = BEnergyGenerator.COMPONENT_TYPE;
  public static String JOINT        = BJoint.COMPONENT_TYPE;
  public static String SENSOR       = BSensor.COMPONENT_TYPE;
  public static String SHIELD       = BShielding.COMPONENT_TYPE;
  public static String WEAPON       = BWeapon.COMPONENT_TYPE;
  public static String ROTATOR      = BAutoRotateJoint.COMPONENT_TYPE;
  public static String UNDEFINED    = BComponent.UNDEFINED_COMPONENT_TYPE;


  protected final static String[] COMPONENT_TYPES =
    { COMPONENT, CONTROLLER, ENERGY, JOINT, ROTATOR, SENSOR, SHIELD, WEAPON, UNDEFINED };
    
  public BComponentType(String value)
    { super(COMPONENT_TYPES, value); }

  



} 