package roboforge.animation.alpha;

public class BLerpChannel implements BAlphaChannel
{
  // Simple linear interpolation channel.

  protected BAlphaValue lo, hi;
    // The low / high values for this channel.
    // low is alpha = 0.0, high is alpha = 1.0.


  public BLerpChannel()
    { }

  public BLerpChannel(BAlphaValue lo, BAlphaValue hi)
    { this.lo = lo; this.hi = hi; }


  public void setLowValue(BAlphaValue lo)
    { this.lo = lo; }

  public void setHighValue(BAlphaValue hi)
    { this.hi = hi; }


  public void evaluate(BAlphaValue value, float alpha)
  {
    value.set(lo);
    value.interpolate(hi, alpha);
  }


  public BAlphaValue getStartValue()
    { return lo.copy(); }


}