package roboforge.net.data;

import roboforge.util.data.*;


public class BBalanceData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BBalanceData(long id)
    { super(id); }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.BALANCE; }


  // Status codes...
  // -------------------------------------------------------------

    // Used in winnerID field.


  // Data fields...
  // -------------------------------------------------------------

  public float currentBalance;
  public float winningBalance;
  // The total of all accounts for this account

  public boolean isFuturePayActive;


  // Accessor methods...
  // -------------------------------------------------------------

}