package roboforge.net.data;

import roboforge.util.data.*;


public class BTournamentImageData extends BAbstractAtom
{

  // Serialization ID.
  // -----------------------------------------------------------

  static final long serialVersionUID = -1L;


  // Constructor...
  // -------------------------------------------------------------

  public BTournamentImageData(long id, byte[] image)
  {
    super(id);
    this.image = image;
  }


  // Type definition...
  // -------------------------------------------------------------

  public int getType()
    { return BDataTypes.TOURNAMENT_IMAGE; }


  // Status codes...
  // -------------------------------------------------------------


  // Data fields...
  // -------------------------------------------------------------

  private byte[] image;

  
  // Accessor methods...
  // -------------------------------------------------------------

  public byte[] getImage()
  {
    return image;
  }
}

