package roboforge.particles.forms;

import javax.vecmath.*;
import javax.media.j3d.*;


public interface BVisualForm
{

  public void setColor(Color4f c);
    // Changes the color of this form.

  public void setTexture(Texture t);
    // Changes the texture of this form.

  public void setSize(float s);
    // Changes the size of this form.

  public void setAdditive(boolean isAdditive);
    // Determines whether this form uses additive
    // or subtractive transparency blending.

} 