package roboforge.particles.looks;


import roboforge.particles.*;

import javax.vecmath.*;
import javax.media.j3d.*;



public class BSystemLookShared
  extends    BSystemAspectAdapter
  implements BSystemLook
{

  protected BParticleLook shared;
    // Particle look, shared by all particles in the system.

  public BSystemLookShared()
    { this(null); }

  public BSystemLookShared(BParticleLook look)
    { setSharedLook(look); }


  public void setSharedLook(BParticleLook look)
    { this.shared = look; }

  public BParticleLook getSharedLook()
    { return shared; }

  public BParticleAspect createParticleAspect(BParticle p)
    throws BParticleSystemException
    { return shared; }

}