package roboforge.util.io;

import roboforge.BGlobal;
import java.io.File;


public class BInternalFilter extends BBasicFilter
{
  // Internal items string.
  public static final String INTERNAL = BGlobal.INTERNAL_ITEM;


  public BInternalFilter()
    { super(); }

  public BInternalFilter(String ext)
    { super(ext); }

  public BInternalFilter(String[] exts)
    { super(exts); }


  public boolean accept(File dir, String name)
  {
    if (name.equalsIgnoreCase(INTERNAL))
      return false;
    else
      return super.accept(dir, name);
  }
}
