package roboforge;

//import java.awt.*;
import javax.swing.*;
//import java.util.*;
//import java.awt.event.*;
//import java.io.*;
//import javax.swing.tree.*;
//import java.beans.*;
//import javax.swing.event.*;
//import javax.swing.border.*;
//import java.net.*;
//import javax.swing.table.*;
//import javax.swing.plaf.*;
//import javax.swing.plaf.basic.*;
//import java.lang.reflect.Array;
//import roboforge.net.*;


public class BTournamentPanel extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -1L;
  /*
  JPanel parentPanel;
  int pWidth;
  int pHeight;
  Border panelBorder;
  String botFileName;

  Vector rows;
  Vector rowsForTable;
  Vector tournament_entry_ids;

  JScrollPane scrollPane;

  // Tournament Table
  JTable tournamentTable;
  JScrollPane tournamentScrollPane = new JScrollPane();

  // Bot Selection Tree
  BFileSelectionTree lastFTree;
  TreePath lastFPath;

  BButton jBSubmit = new BButton();
  BButton jBUpdate = new BButton();
  BButton jBRemove = new BButton();

  JTextArea jTInfo = new JTextArea();
  JLabel jLAccBal = new JLabel();
  JLabel jLtournHeader = new JLabel();
  JScrollPane jSBotNames = new JScrollPane();
  JList jLBotNames = new JList();
  JLabel jLImage = new JLabel();

/*

* Description:
  Allows the user to login to the server

* Example:
* Modification History ( Name, Date, Notes )
  Created HSC, 17 September 1999.


  public BTournamentPanel(JPanel pPanel,int WIDTH,int HEIGHT)
  {
    try
    {
      pWidth = WIDTH;
      pHeight = HEIGHT;
      parentPanel = pPanel;
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception
  {

    // Bot selection tree
    BFileSelectionTree fTree = new BFileSelectionTree(BGlobal.BOTPATH,BGlobal.BOTSUFFIX, "Bot Library",true);
    fTree.putClientProperty("JTree.lineStyle","Angled");
    fTree.addTreeSelectionListener(new FTreeSelectionHandler());

    scrollPane = new JScrollPane(fTree);
    scrollPane.setSize(BGlobal.FRAMEWIDTH/3 - 10*2,BGlobal.FRAMEHEIGHT - 50*4 - 130);
    scrollPane.setLocation(9,230);


    // Set Tree Cell Renderer Parameters
    ComponentUI ftui = fTree.getUI();
    if (ftui instanceof BasicTreeUI)
    {
      fTree.setRowHeight(20);
      ((BasicTreeUI)ftui).setRightChildIndent(21);
      ((BasicTreeUI)ftui).setCollapsedIcon(new ImageIcon(BGlobal.IMAGEPATH+"collapsed.gif"));
      ((BasicTreeUI)ftui).setExpandedIcon(new ImageIcon(BGlobal.IMAGEPATH+"expanded.gif"));
    }
    fTree.setVisible(true);
    fTree.addMouseListener(new MouseAdapter()
    {
      public void mouseClicked(MouseEvent evt)
      {
        loadFilePath();
      }
    });



    this.setLayout(null);
    //this.setSize(pWidth,pHeight);
    this.setSize(new Dimension(569, 506));


    this.setLayout(null);
    panelBorder = BorderFactory.createEtchedBorder();
    this.setBorder(panelBorder);

    //  Setup Table
    tournamentTable = new JTable();
    tournamentTable.getSelectionModel().setSelectionInterval(0,0);
    tournamentTable.getSelectionModel().addListSelectionListener(new ListSelectionListener()
    {
      public void valueChanged(ListSelectionEvent lse)
      {
        if (tournamentTable.getSelectedRowCount() != 0)
        {
          // Update the list of bots entered
          int i = tournamentTable.getSelectedRow();
          Vector botNames = (Vector)((Vector)((Vector)rows.elementAt(i)).elementAt(7)).elementAt(1);
          tournament_entry_ids = (Vector)((Vector)((Vector)rows.elementAt(i)).elementAt(7)).elementAt(0);
          jLBotNames.setListData(botNames);

          // Update the info box
          jTInfo.setText("Tournament "+ (String)((Vector)rows.elementAt(i)).elementAt(0)+ " Selected");

          // Attempt to create the image
          byte[] imageBytes = (byte[])((Vector)rows.elementAt(i)).elementAt(8);

          if (imageBytes != null)
          {
            BDebug.print("Size of image:" + Array.getLength(imageBytes));

            try
            {
              // Turn the imageIcon bytes back into an ImageIcon
              ByteArrayInputStream byteIS = new ByteArrayInputStream(imageBytes);
              ObjectInputStream in = new ObjectInputStream(byteIS);
              ImageIcon imageI = (ImageIcon)in.readObject();

              byteIS.close();
              in.close();

              jLImage.setIcon(imageI);
            }
            catch (Exception e)
            {
              BDebug.print("Error : " + e.getMessage());
            }
          }
        }
      }

    });

    jTInfo.setLineWrap(true);
    jTInfo.setWrapStyleWord(true);
    jTInfo.setBounds(new Rectangle(279, 277, 280, 73));

    jBSubmit.setToolTipText("Submit bots to tournaments");
    jBSubmit.setText("SUBMIT");
    jBSubmit.setBounds(new Rectangle(295, 237, 100, 25));
    jBSubmit.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBSubmit_actionPerformed(e);
      }
    });

    jBUpdate.setToolTipText("Submit bots to tournaments");
    jBUpdate.setText("UPDATE");
    jBUpdate.setBounds(new Rectangle(448, 237, 100, 25));
    jBUpdate.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBUpdate_actionPerformed(e);
      }
    });

    jBRemove.setToolTipText("Remove sumbitted bot from tournament");
    jBRemove.setText("REMOVE");
    jBRemove.setBounds(new Rectangle(448, 365, 100, 25));
    jBRemove.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBRemove_actionPerformed(e);
      }
    });


    tournamentScrollPane.setBounds(new Rectangle(9, 34, 550, 100));
    jLtournHeader.setBounds(new Rectangle(188, 9, 371, 19));
    jLtournHeader.setText("Available Tournaments");
    jLtournHeader.setHorizontalAlignment(SwingConstants.CENTER);
    jLtournHeader.setHorizontalTextPosition(SwingConstants.LEFT);
    jSBotNames.setBounds(new Rectangle(278, 359, 161, 107));
    jLImage.setBounds(new Rectangle(10, 139, 548, 82));
    this.add(tournamentScrollPane, null);
    this.add(scrollPane,null);
    this.add(jLtournHeader, null);
    this.add(jTInfo, null);
    this.add(jBUpdate, null);
    this.add(jBSubmit, null);
    this.add(jLAccBal, null);
    this.add(jBRemove, null);
    this.add(jSBotNames, null);
    this.add(jLImage, null);
    jSBotNames.getViewport().add(jLBotNames, null);
    tournamentScrollPane.getViewport().add(tournamentTable, null);
    jLtournHeader.setBounds(new Rectangle(100, 9, 460, 19));
    jLAccBal.setBounds(new Rectangle(279, 482, 147, 18));


  }


  void jBSubmit_actionPerformed(ActionEvent e)
  {
    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    STransferDetail transferDetail = null;


    try
    {

      // First check that something has been selected in the tables and list box
      if (false)
        {
          // %% Need to fix this up so it actually does the correct checks and
          bAFrame.statusText.setText("Must select a bot and a Tournament to enter it into");
        }
      else
      {
        // Get the selected tournament id
        int i = tournamentTable.getSelectedRow();
        Integer tournamentID = (Integer)((Vector)rows.elementAt(i)).elementAt(6);

        // First Create the transferDetail
        transferDetail = new STransferDetail("ATG",0f,null,null,null,null,tournamentID.intValue(),null,null,null);

        // Get the response
        BRequestDescriptor reqDesc = new BRequestDescriptor("CPT",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
        responseWrapper = SServerAccess.getServerResponse(reqDesc,transferDetail);
       }
      }
      catch (Exception ex)
      {
        BDebug.print(ex.getMessage());
        bAFrame.statusText.setText("Bot not entered in Tournament: " + ex.getMessage());
      }

      // Ok so we got the response back lets see what it is
      if (responseWrapper.getResponseType().equals("CPT"))
      {
        // Everything went ok
        transferDetail = (STransferDetail)responseWrapper.getResponseObject();
        ((BFightPanel)parentPanel).payment.setCallingPanel(this);
        // Time to add the bot to the transferDetail
        transferDetail.setBot(botFileName);

        ((BFightPanel)parentPanel).payment.setTransferDetails(transferDetail);
        ((BFightPanel)parentPanel).payment.setVisible(true);
        this.setVisible(false);
      }
      else if (responseWrapper.getResponseType().equals("ERR"))
      {
        // Problems to resolve\explain to user
        String type = (String)responseWrapper.getResponseObject();
        if (type.equals("NEM"))
        {
          // Not enough money - open the transfer panel to transfer money to the
          // players account from the credit card
          bAFrame.statusText.setText("Insufficient money in account for tournament entry fee - Need to transfer money from credit card");

          // Get the selected tournament amount
          int i = tournamentTable.getSelectedRow();
          Float entryFee = (Float)((Vector)rows.elementAt(i)).elementAt(5);
          // First Create the transferDetail
          //transferDetail = new STransferDetail("ATG",entryFee.floatValue(),null,null,null,null,0,null,null,null);
          transferDetail = new STransferDetail("CTA",entryFee.floatValue(),null,null,null,null,0,null,null,null);

          // Get the response
          try
          {
          BRequestDescriptor reqDesc = new BRequestDescriptor("CPT",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
          responseWrapper = SServerAccess.getServerResponse(reqDesc,transferDetail);
          }
          catch (Exception e1)
          {
            BDebug.print(e1.getMessage());
            bAFrame.statusText.setText("Can't transfer from Card to Account: " + e1.getMessage());
          }
           // Ok so we got the response back lets see what it is
          if (responseWrapper.getResponseType().equals("CPT"))
          {
            // Everything went ok
            transferDetail = (STransferDetail)responseWrapper.getResponseObject();
            transferDetail.transferHeader = "Insufficient money in account for tournament entry fee - Need to transfer money from credit card\n";
            ((BFightPanel)parentPanel).payment.setCallingPanel(this);
            ((BFightPanel)parentPanel).payment.setTransferDetails(transferDetail);
            ((BFightPanel)parentPanel).payment.setVisible(true);
            this.setVisible(false);
          }
          else if (responseWrapper.getResponseType().equals("ERR"))
          {
            type = (String)responseWrapper.getResponseObject();
            if (type.equals("NCC"))
            {
              // Open up the panel to get the new credit card information
              bAFrame.statusText.setText("No Credit Card found please add card");
              this.setVisible(false);
              ((BFightPanel)parentPanel).card.setVisible(true,this,null);
            }
            else
              bAFrame.statusText.setText("Error: " + (String)responseWrapper.getResponseObject());
          }
          else
            bAFrame.statusText.setText("Error: " + (String)responseWrapper.getResponseObject());
        }

        else
          bAFrame.statusText.setText("Error: " + (String)responseWrapper.getResponseObject());
      }
      else
      {
        bAFrame.statusText.setText("Error: Unknown Response Type" + (String)responseWrapper.getResponseObject());
      }

  }


  void jBUpdate_actionPerformed(ActionEvent e)
  {
    setTournaments();
  }

  void jBRemove_actionPerformed(ActionEvent e)
  {
    // Send the Remove Request up to the Server
    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
     try
      {

        // Get the tournment entry id of the selected tournment entry
        Integer selectID = (Integer)tournament_entry_ids.elementAt(jLBotNames.getSelectedIndex());

        BRequestDescriptor reqDesc = new BRequestDescriptor("RBT",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
        responseWrapper = SServerAccess.getServerResponse(reqDesc,selectID);

      }
      catch (Exception ex)
      {
        BDebug.print(ex.getMessage());
        bAFrame.statusText.setText("Couldn't remove Entry: " + ex.getMessage());
      }

      if (responseWrapper.getResponseType().equals("RBT"))
      {
        // All is ok
       bAFrame.statusText.setText("Entry removed");

      }
      else if (responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't remove Entry: " + responseWrapper.getResponseObject());
      }
      else
      {
        // Unexpected Server Response
        bAFrame.statusText.setText("Couldn't remove Entry: Unexpected Server Response");
      }

    // Update the tournament info
    setTournaments();
  }

 

  public void setTournaments()
  {
    // Download the tournament information
    roboforge.internal.BApplicationFrame bAFrame = (roboforge.internal.BApplicationFrame)this.getParent().getParent();
    SResponseWrapper responseWrapper = null;
    try
    {

      // Get the response
      BRequestDescriptor reqDesc = new BRequestDescriptor("GOT",((BFightPanel)parentPanel).loginId,((BFightPanel)parentPanel).password,((BFightPanel)parentPanel).clientPubKey,BGlobal.URLSGATEWAY);
      responseWrapper = SServerAccess.getServerResponse(reqDesc,null);

      if (responseWrapper.getResponseType().equals("GOT"))
      {

        // All is ok
        Vector v = (Vector)responseWrapper.getResponseObject();
        rows = (Vector)v.get(0);
        Vector cols = (Vector)v.get(1);

        /*
        Set up the rows for tables cause funny side effect occur if
        you have different row values from columns while using tables
        *Note all this Kludgy code is because I couldn't workout in the time
        available how to hide columns in a JTable but still be able to access
        their data
        So what I'm doing here is creating a new Vector to hold only the values
        that I show in a table and then reference the original Vector when I want
        values that relate to a row but aren't held in the table - YUK
        //  end comment
        rowsForTable = new Vector();
        // Loop through all the rows
        for (int i=0;i<rows.size();i++)
        {
          // For each row get the Vector of objects
          Vector rowValues = (Vector)rows.elementAt(i);
          // Loop through the first 6 row elements and add them to the
          // new collection - only want the first 6 elements of the vector for the table
          Vector rowValues6 = new Vector();
          for (int j=0;j<6;j++)
          {
            rowValues6.addElement(rowValues.elementAt(j));
          }
          rowsForTable.addElement(rowValues6);
        }

        DefaultTableModel movesTableModel = new DefaultTableModel(rowsForTable,cols);
        tournamentTable.setModel(movesTableModel);

        // Update the account balance
        jLAccBal.setText("Account Balance: $" + (Integer)v.get(2));

        // Clear out the list values
        jLBotNames.setListData(new Vector());


      }
      else if(responseWrapper.getResponseType().equals("ERR"))
      {
        // A Server Login Response
        bAFrame.statusText.setText("Couldn't get Tournaments: " + responseWrapper.getResponseObject());
      }
      else
      {
        // A Server Login Response
        bAFrame.statusText.setText("Unknown Response");
      }
    }
    catch (Exception e)
    {
      bAFrame.statusText.setText("Couldn't get Tournaments: " + e.getMessage());
      System.err.println(e.getMessage());
    }
  }

  // Load File Path
  private void loadFilePath()
  {
    try
    {
      String fname = lastFTree.getPathName(lastFPath);
      File f = new File(fname);
      if (f.isFile())
      {

        // Set the file name of the bot to submit
        int length = fname.length();
        jTInfo.setText("Bot " + fname.substring(0,length-4) + " Selected");
        botFileName = fname;


      }
    }
    catch (Throwable t)
    {
      // Do Nothing
    }
  }


  // LISTENER HANDLERS

  // File Tree
  private class FTreeSelectionHandler implements TreeSelectionListener
  {
    public void valueChanged(TreeSelectionEvent evt)
    {
      try
      {
        lastFPath = evt.getPath();
        lastFTree = (BFileSelectionTree)evt.getSource();
      } catch (Throwable t){
        // Do Nothing
      }
    }
  }

*/
}
