package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

class SChatHandler extends Thread
{
  protected HttpServletRequest request;
  protected HttpServletResponse response;

  protected ObjectInputStream i;
  protected ObjectOutputStream o;

  protected static Vector handlers = new Vector();

  public SChatHandler (HttpServletRequest request, HttpServletResponse response)
  {
    try
    {
      System.out.println("1");
      this.request = request;
      this.response = response;
      this.i = new ObjectInputStream (this.request.getInputStream());
      System.out.println("2");
      this.o = new ObjectOutputStream (this.response.getOutputStream());
      System.out.println("3");
    }
    catch (Exception e)
    {
      System.out.println(e.getMessage());
    }
  }

 public void run()
  {
    try
    {
      handlers.addElement(this);
      while (true)
      {
        String msg = (String)i.readObject();
        System.out.println(msg);
        broadcast (msg);
      }
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
    finally
    {
      handlers.removeElement(this);
    }
  }

  protected static void broadcast (String message)
  {
    synchronized (handlers)
    {
      Enumeration e = handlers.elements();
      while (e.hasMoreElements())
      {
        SChatHandler chatHandler = (SChatHandler)e.nextElement();

        synchronized (chatHandler.o)
        {
          try
          {
            chatHandler.o.writeObject(message);
          }
          catch (Exception e1)
          {
            System.out.println(e1.getMessage());
          }
        }
      }
    }
  }


}
