package roboforge;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;
import java.util.*;
import roboforge.net.BHttpMessage;

import roboforge.*;
import roboforge.net.*;
import roboforge.net.services.*;
import roboforge.net.data.*;
import roboforge.util.io.*;
import roboforge.net.client.*;
import roboforge.util.data.*;

public class SChatTest extends JFrame implements Runnable
{
  JTextArea jTextArea1 = new JTextArea();
  JTextField jTextField1 = new JTextField();
  JButton jButton1 = new JButton();
  protected Thread listener;

  protected ObjectInputStream i;
  protected ObjectOutputStream o;

  protected BClientStack server;
  JTextField jTLoginID = new JTextField();
  JLabel jLabel1 = new JLabel();
  JTextField jTPassowrd = new JTextField();
  JLabel jLabel2 = new JLabel();
  JButton jBDoLogin = new JButton();
  JTextField jTChatRoom = new JTextField();
  JLabel jLabel3 = new JLabel();
  JButton jButton2 = new JButton();
  boolean running = true;


  //Main method
  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
    }
    SChatTest frame = new SChatTest();

    frame.validate();
    frame.setVisible(true);
  }

  //Construct the frame
  public SChatTest()
  {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception
  {
    BGlobal.init();


    jTextArea1.setBounds(new Rectangle(26, 15, 285, 171));
    this.getContentPane().setLayout(null);
    this.setSize(new Dimension(466, 300));
    this.setTitle("Tournament Controller Start Stop");
    jTextField1.setBounds(new Rectangle(27, 215, 280, 21));
    jButton1.setText("Send");
    jButton1.setBounds(new Rectangle(329, 216, 111, 21));
    jButton1.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jButton1_actionPerformed(e);
      }
    });
    jTLoginID.setBounds(new Rectangle(328, 48, 105, 24));
    jLabel1.setText("Login");
    jLabel1.setBounds(new Rectangle(328, 24, 108, 18));
    jTPassowrd.setBounds(new Rectangle(328, 108, 108, 21));
    jLabel2.setText("Password");
    jLabel2.setBounds(new Rectangle(325, 87, 93, 18));
    jBDoLogin.setText("Login");
    jBDoLogin.setBounds(new Rectangle(334, 180, 105, 21));
    jBDoLogin.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jBDoLogin_actionPerformed(e);
      }
    });
    jTChatRoom.setBounds(new Rectangle(331, 150, 105, 24));
    jLabel3.setText("Chat Room");
    jLabel3.setBounds(new Rectangle(334, 132, 99, 15));
    jButton2.setText("jButton2");
    jButton2.setBounds(new Rectangle(329, 252, 108, 18));
    jButton2.addActionListener(new java.awt.event.ActionListener()
    {

      public void actionPerformed(ActionEvent e)
      {
        jButton2_actionPerformed(e);
      }
    });
    this.getContentPane().add(jTextArea1, null);
    this.getContentPane().add(jTextField1, null);
    this.getContentPane().add(jButton1, null);
    this.getContentPane().add(jLabel1, null);
    this.getContentPane().add(jTLoginID, null);
    this.getContentPane().add(jTPassowrd, null);
    this.getContentPane().add(jLabel2, null);
    this.getContentPane().add(jBDoLogin, null);
    this.getContentPane().add(jTChatRoom, null);
    this.getContentPane().add(jLabel3, null);
    this.getContentPane().add(jButton2, null);


    //listener.start();
           // jTextArea1.append(getNextMessage());
  }

  public void run()
  {
    try
    {

      while (running)
      {
        System.out.println("Started");
        //String line = (String)i.readObject();
        jTextArea1.append(getNextMessage());
        System.out.println("Finished");
      }
    }
    catch (Exception e)
    {
      System.out.println(e.getMessage());
    }

  }

  private String getNextMessage()
  {
    String nextMessage = "Not Message";
      try
      {

        BMessage response = null;
        BRequest r = new BRequest(server, "GMES");

        //Long chatRoom = new Long(this.jTChatRoom.getText());

        BCRAuthenticationData authData = new BCRAuthenticationData(server.getAccountID().longValue());

        Long id = new Long(this.jTChatRoom.getText());

        authData.challengeRoomID = id.longValue();
        authData.password = null;

        r.setData(authData);
        // Get the response back from the server...

        BTransmission t = new BTransmission(r);
        response = server.request(t);
        //response = server.request(r,monitor);

        if (response.isAcknowledgement())
        {
          BDebug.print("ACK");
          BDataSet dataSet = (BDataSet)response.getData();

          BDebug.print(dataSet.data.length);
          for (int i = 0; i < dataSet.data.length;i++)
          {
            BDebug.print("*** Got message of type: " + ((BAbstractAtom)dataSet.data[i]).getType());

            if (dataSet.data[i] instanceof BMessageData)
            {

             if (((BMessageData)dataSet.data[i]).isWhisper)
              BDebug.print("This is a Whisper!!!");

              BDebug.print("FROM : " + ((BMessageData)dataSet.data[i]).designerName);

              if (nextMessage == null)
                nextMessage = ((BMessageData)dataSet.data[i]).message;
              else
                nextMessage += "\r\n" + ((BMessageData)dataSet.data[i]).message;
            }

          }
        }
        else
          BDebug.print("NAK");
      }
      catch (Exception e)
      {
        System.out.println("GetMessage Error: " + e.getMessage());

      }

    return nextMessage + "\n";

  }

 /* private SResponseWrapper getTransferResponse (String transferType, String transferError)
  {

   SResponseWrapper responseWrapper = null;


    try
    {
      // Create the request Wrapper
      // STC = S Tournament Client
      SRequestWrapper requestWrapper = new SRequestWrapper("STC", password, transferType,null,null);

      // Verify Stuff
      URL url = new URL(SGlobal.URLSTOURNAMENTCONTROLLER);
      BDebug.print ("Opening Connection");
      URLConnection con = url.openConnection();

      try
      {
        // Send the Request Up
        push(con,requestWrapper);
      }
      catch (PushException pe)
      {
        BDebug.print(pe.getMessage());

      }

      try
      {
        // Get the response back
        responseWrapper = pull(con);
      }
      catch (PullException pue)
      {
        BDebug.print(pue.getMessage());

      }

     }
     catch (MalformedURLException mue)
      {
        BDebug.print(mue.getMessage());

      }
      catch (IOException e1)
      {
        BDebug.print(e1.getMessage());

      }
      catch (Exception ex)
      {
        BDebug.print(ex.getMessage());

      }
      return responseWrapper;
     } */

  public void push (URLConnection connection, String line) throws PushException
  {
    try
    {
      //ByteArrayOutputStream bOS = new ByteArrayOutputStream();
      //ObjectOutputStream OS = new ObjectOutputStream(bOS);
      //OS.writeObject(value);
      //BDebug.print("Size of Object: " + bOS.size());


      connection.setUseCaches(false);
      connection.setRequestProperty("CONTENT_TYPE","application/octet-stream");
      connection.setDoInput(true);
      connection.setDoOutput(true);

      //bOS.writeTo(connection.getOutputStream());
      //bOS.flush();
      //bOS.close();

      PrintWriter writer = new PrintWriter(connection.getOutputStream());

      BDebug.print ("Sending object up stream");

      writer.println(line);

     // os.flush();
     // os.close();
    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PushException("IO Exception");
    }
    catch (Exception ex)
    {
      BDebug.print(ex.getMessage());
      throw new PushException("General Exception");
    }
  }

  public String pull(URLConnection connection) throws PullException
  {
    String response = null;

  try
    {
      //ProgressMonitorInputStream monitor = new ProgressMonitorInputStream (this,"Test",connection.getInputStream());

      //monitor.getProgressMonitor().setMillisToPopup(1);
      //monitor.getProgressMonitor().setMillisToDecideToPopup(0);
      //ObjectInputStream is = new ObjectInputStream(connection.getInputStream());
      InputStreamReader isReader = new InputStreamReader(connection.getInputStream());

      BufferedReader reader = new BufferedReader(isReader);
      //ObjectInputStream is = new ObjectInputStream(monitor);

      BDebug.print ("Getting object back");

      response = reader.readLine();
      //is.close();

    }
    catch (IOException e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("IO Exception");
    }

    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new PullException("General Exception");
    }

    return response;
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e)
  {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      System.exit(0);
    }
  }


  void jButton1_actionPerformed(ActionEvent e)
  {
    try
    {

      BMessage response = null;
      BRequest r = new BRequest(server, "SMES");

      BMessageData messageData = new BMessageData(-1);
      messageData.message = jTextField1.getText();

      Long chatRoom = new Long(this.jTChatRoom.getText());

      //BCRWrapperData wrapperData = new BCRWrapperData(server.getAccountID().longValue());
      BCRWrapperData wrapperData = new BCRWrapperData(chatRoom.longValue());
      wrapperData.destination = BCRWrapperData.SPECIFIED_CHALLENGE_ROOM;
      wrapperData.challengeData = messageData;
      wrapperData.challengeRoomID = chatRoom;
      wrapperData.accountID = server.getAccountID();
      r.setData(wrapperData);

      // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        response = server.request(t);

        if (response.isAcknowledgement())
          BDebug.print("ACK");
        else
          BDebug.print("NAK");


      /*
      String message = jTextField1.getText();

      URL url = new URL("http://server.roboforge.com/servlet/roboforge.SChatServlet");
      //URL url = new URL("http://localhost:8080/servlet/roboforge.SChatServlet");
      //URL url = new URL("http://edge/servlet/roboforge.SChatServlet");
      BHttpMessage msg = new BHttpMessage(url);
      Properties props = new Properties();
      props.put("message",message);
      msg.sendPostMessage(props);
    */
    }
    catch (Exception e1)
    {
      System.out.println(e1.getMessage());
    }
  }

  void jBDoLogin_actionPerformed(ActionEvent e)
  {
    try
    {
      server = new BClientStack();
      //BServerTarget serverTarget = new BServerTarget("http://edge/servlet/roboforge.SChallengeRoomServlet");
      BServerTarget serverTarget = new BServerTarget("http://localhost:8080/servlet/roboforge.SChallengeRoomServlet");
      server.setServerTarget(serverTarget);

      BDebug.print("Account Before Log: " + server.getAccountID());

      server.login(this.jTLoginID.getText(),this.jTPassowrd.getText());
      // Automatically Enter the challenge room

      BDebug.print("Account After Log: " + server.getAccountID());

      BMessage response = null;
      BRequest r = new BRequest(server, "ECR");

      Long chatRoom = new Long(this.jTChatRoom.getText());


      //BIdentData identData = new BIdentData(chatRoom.longValue());
      BCRAuthenticationData authData = new BCRAuthenticationData(server.getAccountID().longValue());
      authData.challengeRoomID = chatRoom.longValue();
      authData.password = null;


      r.setData(authData);

      // Get the response back from the server...
      BTransmission t = new BTransmission(r);
      response = server.request(t);
  

      if (response.isAcknowledgement())
        BDebug.print("ACK");
      else
        BDebug.print("NAK");

        running = true;
        listener = new Thread(this);
        listener.start();
    }
    catch (Exception e11)
    {
      BDebug.print(e11.getMessage());
    }
  }

  void jButton2_actionPerformed(ActionEvent e)
  {

      try
      {

      running = false;
      //BRequest r = new BRequest(server, "EXCR");
      //BRequest r = new BRequest(server, "GMEM");

      //BRequest r = new BRequest(server, "CHAL");
      BRequest r = new BRequest(server, "AFK");

      //BCRAuthenticationData crData = new BCRAuthenticationData(server.getAccountID().longValue());

      //Long id = new Long(this.jTChatRoom.getText());
      //crData.challengeRoomID = id.longValue();
      //crData.password = null;

      //BBot bot = BBot.loadFromFile("y:/data/bot/boo.bot");

      //BCreateChallengeData chalData = new BCreateChallengeData(server.getAccountID().longValue(),bot,null,99,24);
      BCRAuthenticationData authData = new BCRAuthenticationData(server.getAccountID().longValue());
      authData.challengeRoomID = 99;
      authData.afk = true;

      r.setData(authData);

      // Get the response back from the server...
        BTransmission t = new BTransmission(r);
        BMessage response = server.request(t);

        //BDataSet dataSet = (BDataSet)response.getData();

        if (response.isAcknowledgement())
          BDebug.print("ACK");
        else
          BDebug.print("NAK");
      }
      catch (Exception e22)
      {
        BDebug.print(e22.getMessage());
      }
  }
}
