package roboforge;

import java.sql.*;
import java.io.*;
import java.util.*;

public class SDisplayTransBean extends SJDBCBean
{

  private String sql;
  private Statement statement;
  private ResultSet rs;

  private String id;



  private String returnHTML;

  public SDisplayTransBean() throws Exception
  {
    super();
  }


  public void setId(String id)
  {
    this.id   = id;
  }

  public String getReturnHTML()
  {

    Connection con = null;
    String returnHTML = "";
    try
    {
      con = this.getConnection();

      // Request Doesn't involve a WP id
      sql = "SELECT * FROM TRANSACTION WHERE account_id = " + id;
      sql += " ORDER BY transaction_date";

      statement = con.createStatement();
      rs = statement.executeQuery(sql);

      while (rs.next())
      {

        java.util.Date date   = rs.getDate("transaction_date");
        long transID          = rs.getLong("id");
        String type           = rs.getString("type");
        float amount          = rs.getFloat("amount");
        long wpRef            = rs.getLong("wp_ref");
        String status         = rs.getString("status");

        // Build up the returnHTML
        returnHTML += "<form name=\"form1\" method=\"post\" action=\"http://server.rftournaments.com/servlet/roboforge.SControllerServlet?action=UPDTRANS\">";
        returnHTML += "<table width=\"400\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\" bordercolor=\"1\">";
        returnHTML += "<tr bgcolor=\"#FF9933\">";
        returnHTML += "<td colspan=\"12\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Account ID:</b></font></td>";
        returnHTML += "</tr>";
        returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\">TransID</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"text\" name=\"id\" value=\"" + transID + "\"></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Date:</b></font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">" + date + "</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Type:</b></font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">" + type + "</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Amount:</b></font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">" + amount + "</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>WP&nbsp;Ref:</b></font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">" + wpRef + "</font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\"><b>Status:</b></font></td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><font size=\"2\" face=\"Arial, Helvetica, sans-serif\">" + status + "</font></td>";
        returnHTML += "</tr>";
        returnHTML += "<tr>";
        returnHTML += "<td bgcolor=\"#CCCCCC\" colspan=11>&nbsp;</td>";
        returnHTML += "<td bgcolor=\"#CCCCCC\"><input type=\"submit\" name=\"Submit\" value=\"Complete\"></td>";
        returnHTML += "</tr>";
        returnHTML += "</table>";
        returnHTML += "</form>";
      }

      rs.close();
      statement.close();

      return returnHTML;
    }
    catch (Exception e)
    {
      System.err.println("Error: SLoginBean: " + e.getMessage());
    }
    finally
    {
      if (con != null)
        this.freeConnection(con);
    }

    return returnHTML;

  }
}