package roboforge;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.sql.*;
import java.util.Properties;



public class SUnsubscribe extends SHttpServletJXGB
{

  String html;
  //Initialize global variables
  public void init(ServletConfig config) throws ServletException
  {
    super.init(config);

  }

  //Process the HTTP Get request
  public void doGet(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException
  {
    doPost(request, response);
  }
  
  //Process the HTTP Post request
  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
  {

    Connection con = null;
    String email = "";

    Statement statement = null;
    ResultSet rs = null;
    String sql = "";


    try
    {

     // Code to track down the null parameter bug
      if (request == null)
      {
        System.err.println("Error: SUnsubscribe: Request is NULL");
        response.sendRedirect("http://www.roboforge.net/unsuberr.htm");
        return;
      }
      else
      {
        if (request.getParameter("EMAIL")== null )
        {
          // This condition will most likely be reached if a
          // search Robot attempts to link to www.roboforge.net/Servlets/SPreRegisterServlet
          // Get them to contact roboforge
          System.err.println("Error: SUnsubscribe: NULL EMAIL ");
          response.sendRedirect("http://www.roboforge.net/unsuberr.htm");
          return;
        }
      }

      if ((request.getParameter("EMAIL").equals("")))
      {
        // An empty string for either the login or password get them to reenter
        System.err.println("Error: SUnsubscribe: Empty EMAIL ");
        response.sendRedirect("http://www.roboforge.net/unsuberr.htm");
        return;
      }

      email = SServerAccess.parseString(request.getParameter("EMAIL"));
      email = email.trim().toLowerCase();

      // Unsubscribe Account
      sql = "UPDATE ACCOUNT SET subscribed  = 'N' WHERE LOWER(email) = '" + email + "'";
      con = getDatabaseConnection();

      statement = con.createStatement();
      int ok = statement.executeUpdate(sql);
      statement.close();

      con.commit();

      if (ok == 0)
      {
        System.err.println("Error: SUnsubscribe: Couldn't find email");
        response.sendRedirect("http://www.roboforge.net/unsuberr.htm");
        return;
      }
      else
      {
        response.sendRedirect("http://www.roboforge.net/unsubok.htm");
        return;
      }

    }
    catch (Exception e)
    {
      System.err.println("Error SUnsubscribe.doPost: "+ e.getMessage());

      System.out.println("SQL :" + sql);
      response.sendRedirect("http://www.roboforge.net/unsuberr.htm");
      return;

    }
    finally
    {
      try
      {
        if (con!= null)
        {
          myBroker.freeConnection(con);
        }

        if (rs != null)
          rs.close();
        if (statement != null)
          statement.close();

      }
      catch(Exception e3)
      {
        System.err.println("Error SUnsubscribe.myBroker.freeConnection: "+e3.getMessage());
      }
    }


  }
  private Connection getDatabaseConnection()
  {
    Connection con = null;
    try
    {
      con = myBroker.getConnection();  
      /*
      Class.forName ("oracle.jdbc.driver.OracleDriver");
      con = DriverManager.getConnection("jdbc:oracle:thin:@hugh:1521:edge", "edge", "edge");
      */
      //Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
      //con = DriverManager.getConnection("jdbc:odbc:Testy");
    }

    catch (Exception sqle)
    {
      System.err.println("Error SProcessBug.getDatabaseConnection: " + sqle.getMessage());
    }
  return con;
  }
  //Get Servlet information
  public String getServletInfo()
  {
    return "roboforge.SProcessBug Information";
  }
}