package roboforge;

import java.io.*;
import java.util.Vector;
public class SValidation implements Serializable
{
  /*

  * Description:
    Holds the bot and the tournament entry id of an entry submitted to a client
    for validation

  * Example:
  * Modification History ( Name, Date, Notes ):
    Created HSC, 11-February-2000

  */


  private byte[] botBytes;
  int tournamentEntryID;
  Vector uniqueItems;

  public SValidation(byte[] botBytesIn, int tournamentEntryIDIn, Vector uniqueItemsIn)
  {
    botBytes = botBytesIn;
    tournamentEntryID= tournamentEntryIDIn;
    uniqueItems = uniqueItemsIn;
  }

  public byte[] getBotBytes() throws Exception
  {
    try
    {
      return SServerAccess.gzipInflateArray(botBytes);
    }
    catch (Exception e)
    {
      BDebug.print(e.getMessage());
      throw new Exception (e.getMessage());
    }
  }
} 