package roboforge.ai.expressions.parser;

public interface BExpressionIDs
{

  // Symbol IDs
  // -------------------------------------------------------------

  public static final int EOF                = 0;
  public static final int NUMBER             = 1;
  public static final int IDENTIFIER         = 2;
  public static final int STRING             = 3;
  public static final int REFERENCE          = 4;

  public static final int CONSTANT           = 5;

  public static final int LPAREN             = 6;
  public static final int RPAREN             = 7;

  public static final int EQ                 = 8;
  public static final int NEQ                = 9;
  public static final int GTR                = 10;
  public static final int LESS               = 11;
  public static final int GEQ                = 12;
  public static final int LEQ                = 13;

  public static final int AND                = 14;
  public static final int OR                 = 15;
  public static final int NOT                = 16;

  public static final int PLUS               = 17;
  public static final int MINUS              = 18;
  public static final int TIMES              = 19;
  public static final int DIVIDE             = 20;

}
