package roboforge.animation.alpha;

public interface BAlphaChannel
{

  // An alpha-channel maps values in the range [0..1]
  // onto 'alpha values'.  The intention is to provide a
  // framework for time-varying object properties.


  public void evaluate(BAlphaValue value, float alpha);
    // Sets value to reflect the supplied alpha value.

  public BAlphaValue getStartValue();
    // Returns a copy of the starting alpha-value.

} 