package roboforge.animation.alpha;

import javax.vecmath.*;


public class BAlphaTuple3f extends Tuple3f implements BAlphaValue
{

  public BAlphaTuple3f()
    { super(); }

  public BAlphaTuple3f(float x, float y, float z)
    { super(x, y, z); }

  public BAlphaTuple3f(Tuple3f t)
    { super(t); }


  public void set(BAlphaValue v)
    { super.set((Tuple3f) v); }

  public void interpolate(BAlphaValue v, float alpha)
    { super.interpolate((Tuple3f) v, alpha); }

  public BAlphaValue copy()
    { return new BAlphaTuple3f(this); }

}
