package roboforge.animation.alpha;

public interface BAlphaValue
{

  public void set(BAlphaValue v);
    // Sets this alpha-value to match 'v'.

  public void interpolate(BAlphaValue v, float alpha);
    // Linearly interpolates this alpha-value with 'v'.
    // FORMULA: this * (1- alpha)  +  v *alpha.

  public BAlphaValue copy();
    // Creates an alpha value matching this one.

} 