package roboforge.animation.alpha.map;


public class BConstantMap implements BAlphaMap
{
  // BConstantMap maps any given time onto a
  // constant alpha value.

  protected float alpha;
    // Constant alpha value.

  public BConstantMap(float alpha)
    { this.alpha = alpha; }

  public float alpha(float t)
    { return alpha; }

  public boolean isValidTime(float time)
    { return true; }

}