package roboforge.net;

import java.security.*;

public class BRequestDescriptor extends BDescriptor
{
  private String loginId;
  private String password;
  private PublicKey pubKey;
  private transient String url;

  public BRequestDescriptor(String type, String loginId, String password, PublicKey pubKey, String url)
  {
    super(type);
    this.loginId = loginId;
    this.password = password;
    this.pubKey = pubKey;
    this.url = url;
  }

  public String getLoginId()
  {
    return loginId;
  }

  public String getPassword()
  {
    return password;
  }

  public PublicKey getPubKey()
  {
    return pubKey;
  }
  public String getURL()
  {
    return url;
  }
} 
