package roboforge.net.server;

import roboforge.net.*;

import java.io.*;
import java.security.*;
import javax.servlet.*;
import javax.servlet.http.*;



public class BClientTarget extends BTarget
{

  protected HttpServletRequest  request;
  protected HttpServletResponse response;


  protected InputStream  in;
  protected OutputStream out;

  public BClientTarget
    (HttpServletRequest request, HttpServletResponse response)
    throws BNetException
  {
    super();
    this.request  = request;
    this.response = response;
  }


  public InputStream getInputStream() throws IOException
  { 
    if (in == null)
      in = request.getInputStream();
    
    return in; 
  }

  public OutputStream getOutputStream() throws IOException
  { 
    if (out == null)
      out = response.getOutputStream();
  
    return out; 
  }

}