package roboforge.net.services;


public class BMonitorInfo implements BServiceInfo
{
  
  public static final long NONE = -1;
    // No information about estimated size.
  
  protected String message;
  
  protected long estimatedInput;
  protected long estimatedOutput;
  
  
  public BMonitorInfo(String message)
  {
    this.message         = message;
    this.estimatedInput  = NONE;
    this.estimatedOutput = NONE;
  }

  public BMonitorInfo(long in, long out)
  {
    this.message         = null;
    this.estimatedInput  = in;
    this.estimatedOutput = out;
  }

  
  public String getMessage()
    { return message; }

  public long getEstimatedInput()
    { return estimatedInput; }

  public long getEstimatedOutput()
    { return estimatedOutput; }
  
  
}
