package roboforge.net.sockets;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

import roboforge.BDebug;


public class BGenericSocket implements BSocket
{

  protected InputStream  in;
  protected OutputStream out;


  public BGenericSocket(InputStream in, OutputStream out)
  {
    this.in  = in;
    this.out = out;
  }

  public InputStream getInputStream() throws IOException
    { return in; }

  public OutputStream getOutputStream() throws IOException
    { return out; }

  public void flush() throws IOException
    { out.flush(); }
  
  public void close() throws IOException
  {
    if (in  != null) in.close(); 
    if (out != null) out.close(); 
  }
  
}