package roboforge.net.sockets;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;


public interface BSocket
{

  public InputStream getInputStream() throws IOException;
    // Returns an input stream for receiving through this socket.

  public OutputStream getOutputStream() throws IOException;
    // Returns an output stream for sending through this socket.
  
  public void flush() throws IOException;
    // Flushes this socket of data.
  
  public void close() throws IOException;
    // Closes this socket.
}
