package roboforge.particles;

import roboforge.animation.*;

import roboforge.particles.emitters.*;
import roboforge.particles.forces.*;
import roboforge.particles.forms.*;
import roboforge.particles.looks.*;
import roboforge.particles.physics.*;



public interface BParticleSystem extends BAnimation
{

  public boolean isAlive();
    // Returns true if system is still active.

  public boolean isDead();
    // Returns true if system is inactive.

  public boolean isAnimating();
    // Returns true if system is animating.


  public BParticle emitParticle()
    throws BParticleSystemException;
    // Emits a particle, and returns it.

}
