package roboforge.server.util;

import oracle.sql.*;
import oracle.jdbc.driver.*;
import java.io.*;

public class SServerUtility
{

 public static byte[] blobToByteArray (BLOB blob) throws Exception
  {
    byte[] botBytes = null;

    if (blob != null)
    {
      try
      {
        InputStream l_blobStream = blob.getBinaryStream();

        // Open a file stream to save the BLOB data
        ByteArrayOutputStream l_fileOutStream = new ByteArrayOutputStream();

        // Read from the BLOB data input stream, and write to the file output stream
        byte[] l_buffer = new byte[10]; // buffer holding bytes to be transferred
        int l_nbytes = 0;  // Number of bytes read
        while ((l_nbytes = l_blobStream.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

        botBytes = l_fileOutStream.toByteArray();

        l_blobStream.close();
      }
      catch (Exception e)
      {
        System.err.println(e.getMessage());
        throw new Exception(e.getMessage());
      }
    }

    return botBytes;
  }

  public static String blobToString (BLOB blob) throws Exception
  {
    String result = "";

    if (blob != null)
    {
      try
      {
        InputStream l_blobStream = blob.getBinaryStream();

        InputStreamReader inputStreamReader = new InputStreamReader(l_blobStream);

        // Open a file stream to save the BLOB data
        CharArrayWriter l_fileOutStream = new CharArrayWriter();

        // Read from the BLOB data input stream, and write to the file output stream
        char[] l_buffer = new char[10]; // buffer holding bytes to be transferred
        int l_nbytes = 0;  // Number of bytes read
        while ((l_nbytes = inputStreamReader.read(l_buffer)) != -1) // Read from BLOB stream
        l_fileOutStream.write(l_buffer,0,l_nbytes); // Write to file stream

        inputStreamReader.close();

        result = l_fileOutStream.toString();
      }
      catch (Exception e)
      {
        System.err.println(e.getMessage());
        throw new Exception(e.getMessage());
      }
    }

    return result;
  }

}
