package roboforge.ui.components;

import roboforge.BGlobal;

import java.awt.*;
import javax.swing.JRadioButton;
import javax.swing.AbstractButton;

public class BConnectorButton extends BRadioButton
{

  // Member variables...
  // -------------------------------------------------------------

  private static final String uiClassID = "ConnectorButtonUI";


  // Constructors...
  // -------------------------------------------------------------

  public BConnectorButton(BUIResources res, String key)
  {
    super(res, key);
    initializeUI(res, key);
  }


  // Visual Initialization methods...
  // -------------------------------------------------------------

  public void initializeUI(BUIResources res, String key)
  {
    res.initComponent((AbstractButton) this, key);
  }

  // Accessor methods...
  // -------------------------------------------------------------

  public String getUIClassID() {
    return uiClassID;
  }

} 