package roboforge.ui.components;

import roboforge.BGlobal;


public class BMultiLabel extends BTextArea
{

  // Constructor.
  // -------------------------------------------------------------

  public BMultiLabel(BUIResources res, String key)
    { super(res, key); }

  public BMultiLabel()
    { super(); }


  /*
  public boolean isFocusTraversable()
    { return false; }
  */

  public void initializeUI(BUIResources res, String key)
  {
    setOpaque(false);
    setBorder(null);
    setForeground(BGlobal.colors.getDarkShade());

    setLineWrap(true);
    setWrapStyleWord(true);
    setEditable(false);
    setEnabled(false);

    super.initializeUI(res, key);
  }



} 