package roboforge.ui.components;

import roboforge.util.graphics.*;

import java.awt.Color;
import javax.swing.UIDefaults;


public class LazyHSBImageIcon implements UIDefaults.LazyValue
{
  protected String name;
  protected Color color;

  public LazyHSBImageIcon(String name)
    { this(name, null); }

  public LazyHSBImageIcon(String name, Color c)
  {
    this.name  = name;
    this.color = c;
  }

  public Object createValue(UIDefaults table)
    { return BGraphics.getHSBIcon(name, color); }
}