package roboforge.ui.fusion;

import roboforge.BGlobal;
import roboforge.ui.components.border.*;

import java.awt.Color;
import javax.swing.*;
import javax.swing.border.*;



public class FusionListCellRenderer extends DefaultListCellRenderer
{

  
  public FusionListCellRenderer()
  {
    super();

    Color c = BGlobal.colors.getDarkestShade();
    
    noFocusBorder = 
      BorderFactory.createCompoundBorder(
        new BLineBorder(BLineBorder.SIDES_BOTTOM, c),
        new EmptyBorder(2, 5, 2, 5));
    
	  setBorder(noFocusBorder);
  }


  public static class UIResource extends FusionListCellRenderer
    implements javax.swing.plaf.UIResource
    { }
  
} 